/*-------------------------------------------------------------------------
 *
 * funcindex.h--
 *    
 *
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 * $Id: funcindex.h,v 0.2 1996/06/07 01:39:52 am Exp $
 *
 *-------------------------------------------------------------------------
 */
#ifndef _FUNC_INDEX_INCLUDED_
#define _FUNC_INDEX_INCLUDED_

#include "postgres.h"

typedef struct {
#ifndef P95
	int		nargs;
#else /* P95 */
	int	nargs;
#endif /* P95 */
	Oid	arglist[8];
#ifndef P95
	Oid		procOid;
	char16	funcName;
#else /* P95 */
	Oid	procOid;
	NameData funcName;
#endif /* P95 */
} FuncIndexInfo;

typedef FuncIndexInfo	*FuncIndexInfoPtr;

/*
 * some marginally useful macro definitions
 */
#ifndef P95
#define FIgetname(FINFO) (&((FINFO)->funcName.data[0]))
#else /* P95 */
/* #define FIgetname(FINFO) (&((FINFO)->funcName.data[0]))*/
#define FIgetname(FINFO) (FINFO)->funcName.data
#endif /* P95 */
#define FIgetnArgs(FINFO) (FINFO)->nargs
#define FIgetProcOid(FINFO) (FINFO)->procOid
#define FIgetArg(FINFO, argnum) (FINFO)->arglist[argnum]
#define FIgetArglist(FINFO) (FINFO)->arglist

#ifndef P95
#define FIsetname(FINFO,name) strncpy(&((FINFO)->funcName.data[0]), name, 16)
#endif /* P95 */
#define FIsetnArgs(FINFO, numargs) ((FINFO)->nargs = numargs)
#define FIsetProcOid(FINFO, id) ((FINFO)->procOid = id)
#define FIsetArg(FINFO, argnum, argtype) ((FINFO)->arglist[argnum] = argtype)

#define FIisFunctionalIndex(FINFO) (FINFO->procOid != InvalidOid)
#ifndef P95

#define FIcopyFuncInfo(TO, FROM) \
	TO->nargs = FROM->nargs; \
	TO->procOid = FROM->procOid; \
	strncpy(&((TO)->funcName.data[0]), &((FROM)->funcName.data[0]), 16)
#endif /* P95 */

#endif /* FUNCINDEX_H */
