/*-------------------------------------------------------------------------
 *
 * miscam.h--
 *    Access methods for relations that require special naming conventions.
 *    So far:
 *	- Archive relations.
 *	- Mariposa copy fragments.
 *	- Mariposa side files. 
 *	- Oid hash indices for Mariposa copies.
 *
 *    Definitions are in access/common/miscam.c.
 *
 *
 * Copyright (c) 1995, Regents of the University of California
 *
 * $Id: miscam.h,v 1.2 1996/01/28 00:19:07 searcher Exp $
 *
 *-------------------------------------------------------------------------
 */
#ifndef	MISCAM_H
#define MISCAM_H

/*
 * Archive relations.
 */
extern bool IsArchiveRelation(Name rname);
extern void CreateArchiveRelationFromScratch(Oid relid, int natts,
					     TupleDesc tupdesc);
extern void CreateArchiveRelation(Relation rdesc);
extern void DestroyArchiveRelation(Oid relid);
extern Relation OpenArchiveRelation(Oid relid);

/*
 * Mariposa copy fragments.
 */
extern void GenerateCopyName(Name name, Form_pg_class classtup, Oid relid);

/*
 * Mariposa side files.
 */
extern void GenerateSideFileName(Name name, Relation rdesc);
extern void DestroySideFile(Relation rdesc);

/*
 * Oid hash indices for Mariposa copies.
 */
void DefineRelationOidHashIndex(Relation rdesc);
Relation OpenRelationOidHashIndex(Oid relid);

#endif	/* MISCAM_H */
