/*-------------------------------------------------------------------------
 *
 * tupdesc.h--
 *    POSTGRES tuple descriptor definitions.
 *
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 * $Id: tupdesc.h,v 0.3 1996/06/07 01:39:58 am Exp $
 *
 *-------------------------------------------------------------------------
 */
#ifndef	TUPDESC_H
#define TUPDESC_H

#include "postgres.h"
#include "access/attnum.h"
#include "nodes/pg_list.h"	/* for List */
#include "catalog/pg_attribute.h"

/*
 * a TupleDesc is an array of AttributeTupleForms, each of which is a
 * pointer to a AttributeTupleForm
 */
#ifndef P95
typedef AttributeTupleForm      *TupleDesc;
#else /* P95 */
/* typedef AttributeTupleForm      *TupleDesc; */
#endif /* P95 */

#ifdef P95
/* a TupleDesc is a pointer to a structure which includes an array of */
/* AttributeTupleForms, i.e. pg_attribute information, and the size of */
/* the array, i.e. the number of attributes */
/* in short, a TupleDesc completely captures the attribute information */
/* for a tuple */
#endif /* P95 */

#ifdef P95
typedef struct tupleDesc {
    int  natts;
    AttributeTupleForm *attrs;
} *TupleDesc;

#endif /* P95 */
extern TupleDesc CreateTemplateTupleDesc(int natts);

#ifdef P95
extern TupleDesc CreateTupleDesc(int natts, AttributeTupleForm *attrs);

extern TupleDesc CreateTupleDescCopy(TupleDesc tupdesc);

#endif /* P95 */
extern bool TupleDescInitEntry(TupleDesc desc,
			       AttrNumber attributeNumber,
#ifndef P95
			       Name attributeName, 
			       Name typeName, 
#else /* P95 */
			       char *attributeName, 
			       char *typeName, 
#endif /* P95 */
			       int attdim, 
			       bool attisset);

#ifndef P95
extern TupleDesc BuildDescForRelation(List *schema, Name relname);
#else /* P95 */
extern TupleDesc BuildDescForRelation(List *schema, char *relname);
#endif /* P95 */

#endif	/* TUPDESC_H */
