/*-------------------------------------------------------------------------
 *
 * catname.h--
 *    POSTGRES system catalog relation name definitions.
 *
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 * $Id: catname.h,v 0.11 1996/06/07 04:54:41 am Exp $
 *
 *-------------------------------------------------------------------------
 */
#ifndef	CATNAME_H
#define CATNAME_H

#include "postgres.h"

#ifndef P95
extern Name	AggregateRelationName;
extern Name	AccessRelationName;			/* for data broker */
extern Name	AccessMethodRelationName;
extern Name	AccessMethodOperatorRelationName;
extern Name	AccessMethodProcedureRelationName;
extern Name	AttributeRelationName;
extern Name	ContractRelationName;
extern Name	DatabaseRelationName;
extern Name	DefaultsRelationName;
extern Name	DemonRelationName;
extern Name	FragRelationName;
extern Name	GroupRelationName;
extern Name	HasRelationName;			/* for data broker */
extern Name	HostRelationName;
extern Name	IndexRelationName;
extern Name	InheritProcedureRelationName;
extern Name	InheritsRelationName;
extern Name	InheritancePrecidenceListRelationName;
extern Name	LanguageRelationName;
extern Name	LedgerRelationName;
extern Name	ListenerRelationName;
extern Name	LogRelationName;
extern Name	MagicRelationName;
extern Name	NsvcAttrRelationName;
extern Name	NsvcClassRelationName;
extern Name	NsvcFragRelationName;
extern Name	OperatorClassRelationName;
extern Name	OperatorRelationName;
extern Name	ProcedureArgumentRelationName;
extern Name	ProcedureRelationName;
extern Name	Prs2PlansRelationName;
extern Name	Prs2RuleRelationName;
extern Name	Prs2StubRelationName;
extern Name	RelationRelationName;
extern Name	RewriteRelationName;
extern Name	ServerRelationName;
extern Name	StatisticRelationName;
extern Name	TimeRelationName;
extern Name	TypeRelationName;
extern Name	UserRelationName;
extern Name	VariableRelationName;
extern Name	VersionRelationName;
#endif /* P95 */

#ifndef P95
extern Name	SharedSystemRelationNames[17];
#else /* P95 */
#define  AggregateRelationName "pg_aggregate"
#define  AccessMethodRelationName "pg_am"
#define  AccessMethodOperatorRelationName "pg_amop"
#define  AccessMethodProcedureRelationName "pg_amproc"
#define  AttributeRelationName "pg_attribute"
#define  DatabaseRelationName "pg_database"
#define  DefaultsRelationName "pg_defaults"
#define  DemonRelationName "pg_demon"
#define  GroupRelationName "pg_group"
#define  HostsRelationName "pg_hosts"
#define  IndexRelationName "pg_index"
#define  InheritProcedureRelationName "pg_inheritproc"
#define  InheritsRelationName "pg_inherits"
#define  InheritancePrecidenceListRelationName "pg_ipl"
#define  LanguageRelationName "pg_language"
#define  ListenerRelationName "pg_listener"
#define  LogRelationName "pg_log"
#define  MagicRelationName "pg_magic"
#define  OperatorClassRelationName "pg_opclass"
#define  OperatorRelationName "pg_operator"
#define  ProcedureRelationName "pg_proc"
#define  RelationRelationName "pg_class"
#define  RewriteRelationName "pg_rewrite"
#define  ServerRelationName "pg_server"
#define  StatisticRelationName "pg_statistic"
#define  TimeRelationName "pg_time"
#define  TypeRelationName "pg_type"
#define  UserRelationName "pg_user"
#define  VariableRelationName "pg_variable"
#define  VersionRelationName "pg_version"
#endif /* P95 */

#ifndef P95
#define NameIsTypeRelationName(name) (!namestrcmp(name, TypeRelationName))

#else /* P95 */
extern char *SharedSystemRelationNames[];
#endif /* P95 */

#endif	/* CATNAME_H */
