/*-------------------------------------------------------------------------
 *
 * heap.h--
 *    prototypes for functions in lib/catalog/heap.c
 *
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 * $Id: heap.h,v 0.4 1996/06/07 04:54:44 am Exp $
 *
 *-------------------------------------------------------------------------
 */
#ifndef HEAP_H
#define HEAP_H

#ifndef P95
extern Relation heap_creatr(char *relname, unsigned natts,
			    unsigned smgr, AttributeTupleForm att[]);
#else /* P95 */
extern Relation heap_creatr(char *relname, unsigned smgr, TupleDesc att);
#endif /* P95 */

#ifndef P95
extern void CheckAttributeNames(unsigned natts, AttributeTupleForm tupdesc[]);
#endif /* P95 */
extern int RelationAlreadyExists(Relation pg_class_desc, char relname[]);
#ifndef P95
extern void AddNewAttributeTuples(Oid new_rel_oid, unsigned natts,
				  AttributeTupleForm tupdesc[]);
extern void addNewRelationType(Name typeName, Oid new_rel_oid);
#else /* P95 */
extern void addNewRelationType(char *typeName, Oid new_rel_oid);
#endif /* P95 */

extern void AddPgRelationTuple(Relation pg_class_desc,
	Relation new_rel_desc, Oid new_rel_oid, int arch, unsigned natts);

#ifndef P95
extern Oid heap_create(char relname[], int arch, unsigned natts,
		       unsigned smgr, AttributeTupleForm tupdesc[]);
#else /* P95 */
extern Oid heap_create(char relname[], 
		       char *typename,
		       int arch, 
		       unsigned smgr, TupleDesc tupdesc);
#endif /* P95 */

extern void RelationRemoveInheritance(Relation relation);
extern void RelationRemoveIndexes(Relation relation);
extern void DeletePgRelationTuple(Relation rdesc);
extern void DeletePgAttributeTuples(Relation rdesc);
extern void DeletePgTypeTuple(Relation rdesc);
#ifndef P95
extern void DeletePgFragmentTuples(Oid relid, AttrNumber attnum);
#endif /* P95 */
extern void heap_destroy(char relname[]);
#ifdef P95
extern void heap_destroyr(Relation r);
 
extern void InitTempRelList();
extern void AddToTempRelList(Relation r);
extern void RemoveFromTempRelList(Relation r);
extern void DestroyTempRels();
#endif /* P95 */

#endif	/* HEAP_H */
