/*-------------------------------------------------------------------------
 *
 * pg_defaults.h--
 *   definition of the system "defaults" relation (pg_defaults)
 *   along with the relation's initial contents.
 *
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 * $Id: pg_defaults.h,v 0.4 1996/06/07 04:54:55 am Exp $
 *
 * NOTES
 *    the genbki.sh script reads this file and generates .bki
 *    information from the DATA() statements.
 *
 *-------------------------------------------------------------------------
 */
#ifndef PG_DEFAULTS_H
#define PG_DEFAULTS_H

/* ----------------
 *	postgres.h contains the system type definintions and the
 *	CATALOG(), BOOTSTRAP and DATA() sugar words so this file
 *	can be read by both genbki.sh and the C compiler.
 * ----------------
 */
#include "postgres.h"

/* ----------------
 *	pg_defaults definition.  cpp turns this into
 *	typedef struct FormData_pg_defaults
 * ----------------
 */ 
CATALOG(pg_defaults) BOOTSTRAP {
#ifndef P95
    char16 	defname;
    char16 	defvalue;
#else /* P95 */
    NameData 	defname;
    NameData 	defvalue;
#endif /* P95 */
} FormData_pg_defaults;

/* ----------------
 *	Form_pg_defaults corresponds to a pointer to a tuple with
 *	the format of pg_defaults relation.
 * ----------------
 */
typedef FormData_pg_defaults	*Form_pg_defaults;

/* ----------------
 *	compiler constants for pg_defaults
 * ----------------
 */
#ifndef P95
extern Name Name_pg_defaults;

#endif /* P95 */
#define Natts_pg_defaults		2
#define Anum_pg_defaults_defname	1
#define Anum_pg_defaults_defvalue	2


#endif /* PG_DEFAULTS_H */
