/*-------------------------------------------------------------------------
 *
 * pg_magic.h--
 *    definition of the system "magic" relation (pg_magic)
 *    along with the relation's initial contents.
 *
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 * $Id: pg_magic.h,v 0.4 1996/06/07 04:55:03 am Exp $
 *
 * NOTES
 *    the genbki.sh script reads this file and generates .bki
 *    information from the DATA() statements.
 *
 *-------------------------------------------------------------------------
 */
#ifndef PG_MAGIC_H
#define PG_MAGIC_H

/* ----------------
 *	postgres.h contains the system type definintions and the
 *	CATALOG(), BOOTSTRAP and DATA() sugar words so this file
 *	can be read by both genbki.sh and the C compiler.
 * ----------------
 */
#include "postgres.h"

/* ----------------
 *	pg_magic definition.  cpp turns this into
 *	typedef struct FormData_pg_magic
 * ----------------
 */ 
CATALOG(pg_magic) BOOTSTRAP {
#ifndef P95
    char16 	magname;
    char16 	magvalue;
#else /* P95 */
    NameData 	magname;
    NameData 	magvalue;
#endif /* P95 */
} FormData_pg_magic;

/* ----------------
 *	Form_pg_magic corresponds to a pointer to a tuple with
 *	the format of pg_magic relation.
 * ----------------
 */
typedef FormData_pg_magic	*Form_pg_magic;

/* ----------------
 *	compiler constants for pg_magic
 * ----------------
 */
#ifndef P95
extern Name Name_pg_magic;

#endif /* P95 */
#define Natts_pg_magic			2
#define Anum_pg_magic_magname		1
#define Anum_pg_magic_magvalue		2

#endif /* PG_MAGIC_H */
