/* ----------------------------------------------------------------
 *   FILE
 *	pg_plrel.h
 *
 *   DESCRIPTION
 *   tells what relation should be stored on what platter.
 *
 *	the genbki.sh script reads this file and generates .bki
 *	information from the DATA() statements.
 *
 *   IDENTIFICATION
 *	$Header: /usr/local/devel/mariposa/cvs/src/backend/catalog/pg_plrel.h,v 1.2 1995/09/05 09:29:40 aoki Exp $
 * ----------------------------------------------------------------
 */
#ifndef PgPlrelIncluded
#define PgPlrelIncluded		/* do this exactly once */

/* ----------------
 *	postgres.h contains the system type definintions and the
 *	CATALOG(), BOOTSTRAP and DATA() sugar words so this file
 *	can be read by both genbki.sh and the C compiler.
 * ----------------
 */
#include "c.h"
#include "postgres.h"

#ifdef HP_JUKEBOX

CATALOG(pg_plrel) {
     char16 	relname;
     char16	plname;
} FormData_pg_plrel;

/* ----------------
 *	Form_pg_plrel corresponds to a pointer to a tuple with
 *	the format of pg_plrel relation.
 * ----------------
 */
typedef FormData_pg_plrel	*Form_pg_plrel;

/* ----------------
 *	compiler constants for pg_plrel
 * ----------------
 */
extern Name Name_pg_plrel;

#define Natts_pg_plrel			2
#define Anum_pg_plrel_relname		1
#define Anum_pg_plrel_plname		2

/* ----------------
 *	initial contents of pg_plrel
 * ----------------
 */

#endif /* HP_JUKEBOX */

#endif /* PgPlrelIncluded */
