/*-------------------------------------------------------------------------
 *
 * command.h--
 *    prototypes for command.c.
 *
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 * $Id: command.h,v 0.2 1996/06/07 04:55:27 am Exp $
 *
 *-------------------------------------------------------------------------
 */
#ifndef COMMAND_H
#define COMMAND_H

#include "utils/portal.h"
#include "tcop/dest.h"

extern MemoryContext PortalExecutorHeapMemory;

/*
 * PortalCleanup --
 *	Cleans up the query state of the portal.
 *
 * Exceptions:
 *	BadArg if portal invalid.
 */
extern void PortalCleanup(Portal portal);


/*
 * PerformPortalFetch --
 *	Performs the POSTQUEL function FETCH.  Fetches count (or all if 0)
 * tuples in portal with name in the forward direction iff goForward.
 *
 * Exceptions:
 *	BadArg if forward invalid.
 *	"WARN" if portal not found.
 */
#ifndef P95
extern void PerformPortalFetch(String name, bool forward, int count,
			String tag, CommandDest dest);
#else /* P95 */
extern void PerformPortalFetch(char *name, bool forward, int count,
			       char *tag, CommandDest dest);
#endif /* P95 */

/*
 * PerformPortalClose --
 *	Performs the POSTQUEL function CLOSE.
 */
#ifndef P95
extern void PerformPortalClose(String name, CommandDest dest);
#else /* P95 */
extern void PerformPortalClose(char *name, CommandDest dest);
#endif /* P95 */

/*
 * PerformAddAttribute --
 *	Performs the POSTQUEL function ADD.
 */
#ifndef P95
extern void PerformAddAttribute(Name relationName, Name userName,
#else /* P95 */
extern void PerformAddAttribute(char *relationName, char *userName,
#endif /* P95 */
				bool inh, ColumnDef *colDef);

#endif /* COMMAND_H */
