/*-------------------------------------------------------------------------
 *
 * defrem.h--
 *    POSTGRES define and remove utility definitions.
 *
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 * $Id: defrem.h,v 0.3 1996/06/07 04:55:33 am Exp $
 *
 *-------------------------------------------------------------------------
 */
#ifndef	DEFREM_H
#define DEFREM_H

#include "postgres.h"
#include "nodes/pg_list.h"
#include "nodes/primnodes.h"
#include "nodes/parsenodes.h"
#include "tcop/dest.h"

/*
 * prototypes in defind.c
 */
#ifndef P95
extern void DefineIndex(Name heapRelationName, Name indexRelationName,
			Name accessMethodName, List *attributeList,
#else /* P95 */
extern void DefineIndex(char *heapRelationName, 
			char *indexRelationName,
			char *accessMethodName,
			List *attributeList,
#endif /* P95 */
			List *parameterList, Expr *predicate,
			List *rangetable);
#ifndef P95
extern void ExtendIndex(Name indexRelationName, Expr *predicate,
#else /* P95 */
extern void ExtendIndex(char *indexRelationName,
			Expr *predicate,
#endif /* P95 */
			List *rangetable);
#ifndef P95
extern void RemoveIndex(Name name);
#else /* P95 */
extern void RemoveIndex(char *name);
#endif /* P95 */

/*
 * prototypes in define.c
 */
extern void DefineFunction(ProcedureStmt *nameargsexe, CommandDest dest);
#ifndef P95
extern void DefineOperator(Name name, List *parameters);
extern void DefineAggregate(Name name, List *parameters);
extern void DefineType(Name name, List *parameters);
#else /* P95 */
extern void DefineOperator(char *name, List *parameters);
extern void DefineAggregate(char *name, List *parameters);
extern void DefineType(char *name, List *parameters);
#endif /* P95 */

/*
 * prototypes in remove.c
 */
#ifndef P95
extern void RemoveFunction(Name functionName, int nargs, List *argNameList);
extern void RemoveOperator(Name operatorName, Name typeName1, Name typeName2);
extern void RemoveType(Name typeName);
extern void RemoveAggregate(Name aggName);
#else /* P95 */
extern void RemoveFunction(char *functionName, int nargs, List *argNameList);
extern void RemoveOperator(char *operatorName, 
			   char *typeName1, char *typeName2);
extern void RemoveType(char *typeName);
extern void RemoveAggregate(char *aggName);
#endif /* P95 */

#endif	/* DEFREM_H */
