/*-------------------------------------------------------------------------
 *
 * auth.h--
 *    Definitions for network authentication routines
 *
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 * $Id: auth.h,v 0.2 1996/06/07 04:56:35 am Exp $
 *
 *-------------------------------------------------------------------------
 */
#ifndef AUTH_H
#define	AUTH_H

#include "c.h"
#include "libpq/pqcomm.h"

/*----------------------------------------------------------------
 * Common routines and definitions
 *----------------------------------------------------------------
 */

/* what we call "no authentication system" */
#define	UNAUTHNAME		"unauth"

/* what a frontend uses by default */
#if !defined(KRB4) && !defined(KRB5)
#define	DEFAULT_CLIENT_AUTHSVC	UNAUTHNAME
#else /* KRB4 || KRB5 */
#define	DEFAULT_CLIENT_AUTHSVC	"kerberos"
#endif /* KRB4 || KRB5 */

extern int fe_sendauth(MsgType msgtype, Port *port, char *hostname);
extern void fe_setauthsvc(char *name);
extern MsgType fe_getauthsvc();
extern char *fe_getauthname(void);
#ifndef P95
extern int be_recvauth(MsgType msgtype, Port *port, char *username);
#else /* P95 */
extern int be_recvauth(MsgType msgtype, Port *port, char *username, StartupInfo* sp);
#endif /* P95 */
extern void be_setauthsvc(char *name);
extern int be_getauthsvc(MsgType msgtype);
#ifdef P95

/* the value that matches any dbName value when doing
   host based authentication*/
#define ALL_DBNAME      "*"
#endif /* P95 */

#define	PG_KRB4_VERSION	"PGVER4.1"	/* at most KRB_SENDAUTH_VLEN chars */
#define	PG_KRB5_VERSION	"PGVER5.1"

#endif /* AUTH_H */
