/*-------------------------------------------------------------------------
 *
 * main.c--
 *    Stub main() routine for the postgres backend.
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *    $Header: /usr/local/devel/mariposa/cvs/src/backend/main/main.c,v 0.3 1996/06/07 04:56:48 am Exp $
 *
 *-------------------------------------------------------------------------
 */
#include <string.h>
#include "c.h"
#include "miscadmin.h"
#include "bootstrap/bootstrap.h"	/* for BootstrapMain() */
#include "tcop/tcopprot.h"		/* for PostgresMain() */
#include "port-protos.h"		/* for init_address_fixup() */

#ifndef P95
char *DataDir;

#endif /* P95 */
int
main(int argc, char *argv[])
{
#ifdef P95
    int len;
#endif /* P95 */
#if defined(NOFIXADE) || defined(NOPRINTADE)
    /*
     * Must be first so that the bootstrap code calls it, too.
     * (Only needed on some RISC architectures.)
     */
    init_address_fixup();
#endif /* NOFIXADE || NOPRINTADE */
    
#ifndef P95
    /* 
     * set up DataDir here; it's used by the bootstrap and regular systems 
     */
    DataDir = GetPGData();
#else /* P95 */
    /* use one executable for both postgres and postmaster,
       invoke one or the other depending on the name of the executable */
    len = strlen(argv[0]);
    if(len >= 10 && ! strcmp(argv[0] + len - 10, "postmaster"))
        exit(PostmasterMain(argc, argv));

    /* if the first argument is "-boot", then invoke the backend in
       bootstrap mode */
#endif /* P95 */
    if (argc > 1 && strcmp(argv[1], "-boot") == 0)
#ifndef P95
	exit(BootstrapMain(argc, argv));
#else /* P95 */
	exit(BootstrapMain(argc-1, argv+1)); /* remove the -boot arg from the command line */
#endif /* P95 */
    else
	exit(PostgresMain(argc, argv));
}
