# Mariposa makefile
ifndef P95
#-------------------------------------------------------------------------
#
# Makefile.inc--
#    Makefile for the parser module
#
# Copyright (c) 1994, Regents of the University of California
#
#
# IDENTIFICATION
#    $Header: /usr/local/devel/mariposa/cvs/src/backend/parser/Makefile.inc,v 0.7 1996/06/07 04:57:42 am Exp $
#
#-------------------------------------------------------------------------

parsedir:= $(CURDIR)/parser
VPATH:= $(VPATH):$(parsedir)

PARSEYACCS= gram.c parse.h

$(PARSEYACCS): gram.y
	cd $(objdir); \
	yacc $(YFLAGS) $<; \
	sed -f $(parsedir)/parse.sed < y.tab.c > gram.c; \
	mv y.tab.h parse.h; \
	rm -f y.tab.c

$(objdir)/gram.o: gram.c
	$(cc_inobjdir)

$(objdir)/gram.d: gram.c
	$(mkdep_inobjdir)


scan.c:	scan.l
	cd $(objdir); lex $<; \
	sed -f $(parsedir)/parse.sed < lex.yy.c > scan.c; \
	rm -f lex.yy.c

$(objdir)/scan.o: scan.c
	$(cc_inobjdir)

$(objdir)/scan.d: scan.c
	$(mkdep_inobjdir)


SRCS_PARSER+= analyze.c catalog_utils.c dbcommands.c gram.c io.c \
	keywords.c parser.c parse_query.c scan.c scanner.c 

CLEANFILES+= scan.c ${PARSEYACCS}

POSTGRES_DEPEND+= scan.c $(PARSEYACCS)

#.if ${PORTNAME} == "bsd44"
#YFLAGS+= -l
#.endif

HEADERS+= catalog_utils.h io.h parse_query.h parsetree.h \
	dbcommands.h keywords.h
# Postgres95 makefile
else # P95
#-------------------------------------------------------------------------
#
# Makefile.inc--
#    Makefile for the parser module
#
# Copyright (c) 1994, Regents of the University of California
#
#
# IDENTIFICATION
#    $Header: /usr/local/devel/mariposa/cvs/src/backend/parser/Makefile.inc,v 0.7 1996/06/07 04:57:42 am Exp $
#
#-------------------------------------------------------------------------

VPATH:= $(VPATH):$(CURDIR)/parser

#PARSEYACCS= gram.c parse.h
PARSEYACCS= gram.c

$(PARSEYACCS): gram.postgres95.y
	cd $(objdir); \
	$(YACC) $(YFLAGS) $<; \
	mv y.tab.c gram.c; \
	mv y.tab.h parse.h

$(objdir)/gram.o: gram.c
	$(cc_inobjdir)


scan.c:	scan.postgres95.l
	cd $(objdir); $(LEX) $<; mv lex.yy.c scan.c

$(objdir)/scan.o: scan.c
	$(cc_inobjdir)


SRCS_PARSER+= analyze.c catalog_utils.c dbcommands.c gram.c \
	keywords.c parser.c parse_query.c scan.c scansup.c 

CLEANFILES+= scan.c ${PARSEYACCS}

POSTGRES_DEPEND+= scan.c $(PARSEYACCS)

HEADERS+= catalog_utils.h io.h parse_query.h parsetree.h \
	dbcommands.h keywords.h


endif # P95
