/*-------------------------------------------------------------------------
 *
 * catalog_utils.h--
 *    
 *
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 * $Id: catalog_utils.h,v 0.4 1996/06/07 04:57:45 am Exp $
 *
 *-------------------------------------------------------------------------
 */
#ifndef	CATALOG_UTILS_H
#define	CATALOG_UTILS_H


#include "postgres.h"

#include "access/htup.h"
#include "utils/rel.h"
#include "catalog/pg_proc.h"
#include "catalog/pg_type.h"
#include "utils/syscache.h"
    
typedef HeapTuple	Type;
typedef HeapTuple	Operator;

extern	Oid	typeid_get_relid();

extern bool check_typeid(long id);
extern Type get_id_type(long id);
#ifndef P95
extern Name get_id_typname(long id);
#else /* P95 */
extern char *get_id_typname(long id);
#endif /* P95 */
extern Type type(char *);
extern Oid att_typeid(Relation rd, int attid);
extern int att_attnelems(Relation rd, int attid);
extern Oid typeid(Type tp);
extern int16 tlen(Type t);
extern bool tbyval(Type t);
#ifndef P95
extern Name tname(Type t);
#else /* P95 */
extern char *tname(Type t);
#endif /* P95 */
extern int tbyvalue(Type t);
extern Oid oprid(Operator op);
extern Operator oper(char *op, int arg1, int arg2);
extern Operator right_oper(char *op, int arg);
extern Operator left_oper(char *op, int arg);
extern int varattno(Relation rd, char *a);
extern bool varisset(Relation rd, char *name);
extern int nf_varattno(Relation rd, char *a);
#ifndef P95
extern Name getAttrName(Relation rd, int attrno);
/*extern int RangeTablePosn(char *rangevar); */
#else /* P95 */
extern char *getAttrName(Relation rd, int attrno);
#endif /* P95 */
extern char *outstr(char *typename, char *value);
#ifndef P95
extern char *instr2(Type tp, char *string);
extern char *instr1(TypeTupleForm tp, char *string);
#else /* P95 */
extern char *instr2(Type tp, char *string, int typlen);
extern char *instr1(TypeTupleForm tp, char *string, int typlen);
#endif /* P95 */
extern Oid GetArrayElementType(Oid typearray);
#ifndef P95
extern char *instr(char *typename, char *string);
#endif /* P95 */
extern Oid funcid_get_rettype(Oid funcid);
extern bool func_get_detail(char *funcname, int nargs, Oid *oid_array,
	    Oid *funcid, Oid *rettype, bool *retset, Oid **true_typeids);
extern Oid typeid_get_retinfunc(int type_id);
extern Oid typeid_get_relid(int type_id);
extern Oid get_typrelid(Type typ);
extern Oid get_typelem(Oid type_id);
extern char FindDelimiter(char *typename);
extern void op_error(char *op, int arg1, int arg2);
extern void func_error(char *caller, char *funcname, int nargs, int *argtypes);

#endif	/* CATALOG_UTILS_H */
