# Mariposa makefile
ifndef P95
#-------------------------------------------------------------------------
#
# Makefile.inc--
#    Makefile for port/aix (AIX specific stuff)
#
# Copyright (c) 1994, Regents of the University of California
#
#
# IDENTIFICATION
#    $Header: /usr/local/devel/mariposa/cvs/src/backend/port/aix/Makefile.inc,v 0.4 1996/06/07 04:58:03 am Exp $
#
#-------------------------------------------------------------------------

#
# aix has fast linkers and don't need the BIGOBJ stuff.
#
BIGOBJS=false

CFLAGS+= -DCLASS_CONFLICT -DDISABLE_XOPEN_NLS -DNEED_ISINF

LDFLAGS+= -bE:${PROG}.exp

LDADD+= -lld

HEADERS+= dlfcn.h machine.h port-protos.h

SUBSRCS+= dlfcn.c 

${PROG}.exp: ${PROG}.noexp
	mv -f ${.ALLSRC} ${PROG}
	mkldexport ${PROG} ${BINDIR} > ${.TARGET}
	mv -f ${PROG} ${.ALLSRC}

${PROG}.noexp: ${OBJS}
	touch -f ${PROG}.exp
	${CC} ${LDFLAGS} -o ${.TARGET} ${OBJS} ${LDADD}

EXPORTS= ${PROG}.exp

CLEANFILES+= ${PROG}.noexp ${PROG}.exp
# Postgres95 makefile
else # P95
#-------------------------------------------------------------------------
#
# Makefile.inc--
#    Makefile for port/aix (AIX specific stuff)
#
# Copyright (c) 1994, Regents of the University of California
#
#
# IDENTIFICATION
#    $Header: /usr/local/devel/mariposa/cvs/src/backend/port/aix/Makefile.inc,v 0.4 1996/06/07 04:58:03 am Exp $
#
#-------------------------------------------------------------------------

#
# aix has fast linkers and don't need the BIGOBJ stuff.
#
BIGOBJS=false

CFLAGS+= -DCLASS_CONFLICT -DDISABLE_XOPEN_NLS -DNEED_ISINF

LDFLAGS+= -bE:$(objdir)/$(PROG).exp

LDADD+= -ll -lld

HEADERS+= dlfcn.h machine.h port-protos.h

SUBSRCS+= dlfcn.c 

${PROG}.exp: ${PROG}.noexp
	mv -f $(objdir)/${PROG}.noexp $(objdir)/${PROG}
	$(CURDIR)/port/aix/mkldexport.sh $(objdir)/${PROG} ${BINDIR} > $(objdir)/${PROG}.exp
	mv -f $(objdir)/${PROG} $(objdir)/${PROG}.noexp

${PROG}.noexp: ${OBJS}
	touch -f $(objdir)/${PROG}.exp
	${CC} ${LDFLAGS} -o $(objdir)/${PROG}.noexp ${OBJS} ${LDADD}

EXPORTS= ${PROG}.exp

CLEANFILES+= ${PROG}.noexp ${PROG}.exp
endif # P95
