#!/bin/sh
#-------------------------------------------------------------------------
#
# Gen_rpccalls.sh--
#    generates rpccalls.h and rpccalls.c from mariposa_rpc.x
#
# Copyright (c) 1994-5, Regents of the University of California
#
#
# IDENTIFICATION
#    $Header: /usr/local/devel/mariposa/cvs/src/backend/rpc/Gen_rpccalls.sh,v 1.1 1995/04/22 08:20:56 andrew Exp $
#
#-------------------------------------------------------------------------

XDRPROTOFILE=$1
RAWFILE=rpccalls.raw
HFILE=rpccalls.h
CFILE=rpccalls.c

cat $XDRPROTOFILE | grep -v '^%' | egrep '\(.*\).*=' | \
	sed -e 's/(/\ /g' -e 's/)/\ /g' > $RAWFILE

cat > $HFILE <<FuNkYxDrStUfF
/*-------------------------------------------------------------------------
 *
 * $HFILE--
 *    Definitions for using Rpc_call.
 *
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 * $Id: Gen_rpccalls.sh,v 1.1 1995/04/22 08:20:56 andrew Exp $
 *
 * NOTES
 *      ******************************
 *      *** DO NOT EDIT THIS FILE! ***
 *      ******************************
 *
 *      It has been GENERATED by $0
 *      from $1
 *
 *-------------------------------------------------------------------------
 */
#ifndef RPCCALLS_H
#define RPCCALLS_H

#include <rpc/rpc.h>

typedef struct RpcCallDesc {
    int		rpc_call_id;
    xdrproc_t	rpc_xdr_in;
    xdrproc_t	rpc_xdr_out;
} RpcCallDesc;

FuNkYxDrStUfF

awk '{printf "extern RpcCallDesc *RPC_%s;\n", $2}' $RAWFILE >> $HFILE
echo '#endif /* RPCCALLS_H */' >> $HFILE

XDRHEADER=`echo $XDRPROTOFILE| sed -e 's/^.*\///g' -e 's/.x$//g'`
cat > $CFILE <<FuNkYxDrCfStUfF
/*-------------------------------------------------------------------------
 *
 * $CFILE--
 *    Definitions for using Rpc_call.
 *
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 * $Id: Gen_rpccalls.sh,v 1.1 1995/04/22 08:20:56 andrew Exp $
 *
 * NOTES
 *      ******************************
 *      *** DO NOT EDIT THIS FILE! ***
 *      ******************************
 *
 *      It has been GENERATED by $0
 *      from $1
 *
 *-------------------------------------------------------------------------
 */
#include "rpccalls.h"
#include "$XDRHEADER.h"		/* for xdr_* prototypes */


FuNkYxDrCfStUfF

awk '{printf "RpcCallDesc RPC_%s_desc =\n\t{ %s, xdr_%s, xdr_%s };\nRpcCallDesc *RPC_%s\n\t= &RPC_%s_desc;\n\n", $2, $2, $3, $1, $2, $2}' $RAWFILE >> $CFILE

/bin/rm -f $RAWFILE

