#-------------------------------------------------------------------------
#
# Makefile.inc--
#    Makefile for RPC stuff 
#
# Copyright (c) 1994, Regents of the University of California
#
#
# IDENTIFICATION
#    $Header: /usr/local/devel/mariposa/cvs/src/backend/rpc/Makefile.inc,v 1.25 1996/06/14 20:23:10 jsidell Exp $
#
#-------------------------------------------------------------------------

rpcdir:= $(CURDIR)/rpc
VPATH:=$(VPATH):$(rpcdir)


#
# These rules apply to XDR files.
#
$(objdir)/%.h:	%.x
	rpcgen -h -o $@ $<

# we have to modify the (absolute) pathname in the generated #include
# of the corresponding .h file to not include any directory information
# -- this file resides in the .obj directory
$(objdir)/%.xdr.c:  %.x
	cd $(objdir); \
	rpcgen -c -o $(@F) $<; \
	sed -e 's%^#.*/$(basename $(<F))\.h%#include "$(basename $(<F)).h%' $(@F) > $(@F).tmp; \
	mv $(@F).tmp $(@F)


GENRPCHDRS= brokerRPC.h mariposa_rpc.h exchange.h queries.h rpctypes.h \
	datafrag.h namesvc.h optimizerRPC.h syncFrag.h schedRPC.h bid.h \
	rpccalls.h copies.h nameserver_mk.h \
	twopc.h databroker.h

GENRPCSRCS= brokerRPC.xdr.c exchange.xdr.c queries.xdr.c \
	rpctypes.xdr.c datafrag.xdr.c schedRPC.xdr.c bid.xdr.c \
	namesvc.xdr.c optimizerRPC.xdr.c syncFrag.xdr.c \
	copies.xdr.c rpccalls.c nameserver_mk.xdr.c \
	twopc.xdr.c databroker.xdr.c


GENRPCCALLS= $(rpcdir)/Gen_rpccalls.sh
GENRPCCALLSFILES= rpccalls.c $(objdir)/rpccalls.h 

$(GENRPCCALLSFILES): $(GENPRCCALLS) $(rpcdir)/mariposa_rpc.x
	cd $(objdir); \
	sh $(SHOPTS) $(GENRPCCALLS) $(rpcdir)/mariposa_rpc.x

$(objdir)/rpccalls.o:  rpccalls.c
	$(cc_inobjdir)
$(objdir)/rpccalls.d:  rpccalls.c
	$(mkdep_inobjdir)


POSTGRES_DEPEND+= call_exec.h $(addprefix $(objdir)/,$(GENRPCHDRS)) \
	 $(addprefix $(objdir)/,$(GENRPCSRCS))

CLEANFILES+= $(GENRPCHDRS) $(GENRPCSRCS)

HEADERS+= call_exec.h nameserver.h rexec.h fragutils.h $(GENRPCHDRS)

SRCS_RPC= exchange.c call_exec.c rpc_server.c queries.c $(GENRPCSRCS) \
	schedRPC.c \
	copies_be.c datafrag.c namesvc_be.c nameserver.c optimizerRPC.c \
	syncFrag.c rpcutils.c rexec.c fragutils.c twopc.c

SRCS_SITEMGR+= exchange.c call_exec.c $(GENRPCSRCS) \
	schedRPC.c namesvc_sm.c copies_sm.c rpcutils.c

