/*-------------------------------------------------------------------------
 *
 * brokerRPC.x--
 *    
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 * $Id: brokerRPC.x,v 1.4 1996/02/26 16:21:45 jsidell Exp $
 *
 *-------------------------------------------------------------------------
 */
#ifdef RPC_HDR
%#ifndef BROKERRPC_H
%#define BROKERRPC_H
%
%#include "bid.h"
%#include "mariposa_rpc.h"
%#include "queries.h"
%#include "nodes/plannodes.h"
%#include "nodes/parsenodes.h"
%#include "nodes/xdrfuncs.h"
%#include "nodes/pqa.h"

#endif

/*
 * Stuff sent to a backend Broker during subcontracting
 */
struct BrokerArg {
    int operation;			/* queryDesc->operation					*/
    int protocol;			/* What we're doing: LONG_X where X=PROCESS_QUERY,
					   SELL_FRAGMENT, etc. 					*/
    PQA_Plan_tree plan;			/* Query plan 						*/
    PQA_Node_list rtable;		/* Range table						*/
    int parentContract;			/* The ID of the parent contract at the sitemgr.	*/

    SiteAddr homeSiteAddr;		/* Address information of the home site.		*/
};

/*
 * Stuff sent back from the Broker
 */
struct BrokerAnswer {
    PQA_Plan_tree plan;			/* The plan tree, with the processing sites filled in.  */
    Budget bid;
};

#ifdef RPC_HDR
%
%void
%execProcessQuery(SiteAddr *addr, ProcessQueryArg *arg);
%
%extern void sitemgrBackendDone(int pid);
%
%extern void handleCall(void *arg);
%
%/* in tcop/pquery.c */
%extern void ProcessRemoteQuery(ProcessQueryArg *queryArg);
%
%#endif
#endif


