/*-------------------------------------------------------------------------
 *
 * call_exec.h--
 *    interface for call-facility into executor running in main thread of
 *    backend
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 * $Id: call_exec.h,v 1.4 1995/04/24 18:58:43 andrew Exp $
 *
 *-------------------------------------------------------------------------
 */
#ifndef CALL_EXEC_H
#define CALL_EXEC_H

#include <rpc/rpc.h>
#include "rpc/rpcutils.h"

typedef void (*FreeProc)(void *, SVCXPRT *);
    /* used by exec. to free memory passed to it */

extern void callExec(thdproc_t reqProc, bool_t reqInXact, void *arg,
		     void *result, FreeProc freeProc,
		     SVCXPRT *transportHandle);

extern void getRequest(thdproc_t *reqProc, bool_t *reqInXact, void **arg,
		       void **result, FreeProc *freeProc,
		       SVCXPRT **transportHandle);

extern void returnResult(void);

#endif	/* CALL_EXEC_H */
