/*-------------------------------------------------------------------------
 *
 * exchange.x--
 *    
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 * $Id: exchange.x,v 1.9 1996/05/31 17:14:13 jsidell Exp $
 *
 *-------------------------------------------------------------------------
 */
#ifdef RPC_HDR
%#ifndef EXCHANGE_H
%#define EXCHANGE_H
%
%#define SENDBUFSIZE 7168
%#define MAXRECVCHANNELS 128
%#define MAXSENDCHANNELS 128
%#define MAXBUFFERS 16
%
%#include <rpc/rpc.h>
%#include <rpc/types.h>
%#if !defined(SOCK_STREAM)
%#include <sys/socket.h>
%#endif /* !socket.h */
%#include <netdb.h>
#endif
%#include "include/c.h"
%#include "rpctypes.h"

/*typedef int TransactionId;
typedef int CommandId;*/
typedef int QepFragmentId;
/*typedef char *Tuple;
typedef int TypeId;*/

#ifdef RPC_HDR
%/* constants for TransmitBuffer.flags */
%#define TransmitMoreData 0x01
%#define TransmitDoConversion 0x02
#endif

typedef opaque Data<>;

%/* Incremented in ReceiveData in rpc/exchange.c */
%int nBuffersReceived;

%/* Incremented in ReceiveData in rpc/exchange.c */
%int nBuffersSent;

enum ReceiverStatus {
	RECEIVER_STATUS_OK,
	RECEIVER_STATUS_BLOCKED
};

struct TransmitBuffer {
    SiteAddr sendingSite;
    /*TransactionId globalXactId;
    CommandId cmdId;*/
    QepFragmentId sendQepFragId;
        /* needed at recv if multiple channels are open */
    QepFragmentId recvQepFragId; /* needed for forwarding by site mgr */
    int flags;
    Data data;
};

%/*
% * Used to call UnblockReceiver
% */
struct UnblockBuffer {
    QepFragmentId sendQepFragId;
    QepFragmentId recvQepFragId;
};

#ifdef RPC_HDR
%/* other */
%
%/* ExchOut (client) interface */
%/*#define SITEMGRPORT xxx */
%
%typedef struct _ExchSendChannelData *ExchSendChannel;
%
%/* interface procedures */
%ExchSendChannel
%openSendChannel(SiteAddr recvSites[], int nRecvSites,
%    /*TransactionId globalXact, CommandId cmd,*/ QepFragmentId sendQepFrag,
%    QepFragmentId recvQepFrags[]/*, TypeId type*/);
%/* Opens sending channel. Data sent through it will go to all designated 
%   recvQepFrags at designated recvSites */
%
%void
%sendTuple(ExchSendChannel channel, Pointer tuple);
%/* Sends tuple through channel */
%
%void
%closeSendChannel(ExchSendChannel channel);
%/* Closes channel and destroys all associated data structures */
%
%
%/* ExchIn (server) interface */
%
%typedef struct _ExchRecvChannelData *ExchRecvChannel;
%
%/* interface procedures */
%ExchRecvChannel
%openRecvChannel(SiteAddr sendSites[], int nSendSites,
%   /*TransactionId globalXact, CommandId cmd,*/ QepFragmentId recvQepFrag,
%   QepFragmentId sendQepFragIds[] /*, TypeId type*/);
%/*
% * Opens a receiving channel that collects input from the designated
% * sendQepFragIds coming from the designated sendSites. The input is delivered
% * in any order. 
% */
%
%void
%recvTuple(ExchRecvChannel channel, Pointer *tuple);
%/* 
% * Returns a tuple and TRUE, if everything was successful. To indicate the
% * end of the input, it return TRUE and a NULL tuple. For transmission errors,
% * it returns FALSE.
% */
%
%void
%closeRecvChannel(ExchRecvChannel channel);
%/* 
% * Closes the previously opened receiving channel and deallocates all
% * associated data structures.
% */
%
%extern void receiveData(void *arg);
%
%extern void ReceiverUnblocked(void *arg);
%
%/* 
% * Resets the buffers sent/received statistics
% */
%
%extern void ResetNetworkStats();
%
%#endif
#endif
