/*-------------------------------------------------------------------------
 *
 * mariposa_rpc.x--
 *    
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 * $Id: mariposa_rpc.x,v 1.34 1996/06/14 20:23:12 jsidell Exp $
 *
 *-------------------------------------------------------------------------
 */
#ifdef RPC_HDR
%#ifndef MARIPOSA_RPC_H
%#define MARIPOSA_RPC_H
%#include "rpctypes.h"
%#include "datafrag.h"
%#include "namesvc.h"
%#include "optimizerRPC.h"
%#include "schedRPC.h"
%#include "syncFrag.h"
%#include "bid.h"
%#include "brokerRPC.h"
%#include "copies.h"
%#include "nameserver_mk.h"
%#include "twopc.h"
%#include "databroker.h"
#
#endif

program EXECPROG {
    version EXECVERS {
	ReceiverStatus TRANSMITDATA(TransmitBuffer) = 1;
	void PROCESSQUERY(ProcessQueryArg) = 2;
	int FRAGXSETUP(FragXArg) = 3;
	void SYNCPUTFRAGMENT(SyncFragmentArg) = 4;
	void SYNCGETFRAGMENT(SyncFragmentArg) = 5;
	void BROKERDONE(BrokerAnswer) = 6;
	FragDataBuffer FRAGIDS(int) = 7;
	FragDataBuffer CLASSES(void) = 8;

	RPCErrorCode ESTABLISHCOPY(CopySetupInfo) = 9;
	SendUpdateStreamResult CP_SENDUPDATESTREAM(UpdateContractInfo) = 10;
	RPCErrorCode CP_PUTUPDATE(TransferDataBuffer) = 11;
	RPCErrorCode CP_INITIALIZEUPDATESTREAMS(void) = 12;
	RPCErrorCode CANCELCONTRACT(int) = 13;
	void RECEIVERUNBLOCKED(UnblockBuffer) = 14;

	RPCErrorCode EXTRACTPREPARATIONS(FragXArg) = 20;
	void FRAGSTARTXFER(SiteAddr) = 21;
	RPCErrorCode FRAGPUTCAT(FragCatalogInfo) = 22;
	RPCErrorCode FRAGPUTDATA(FragDataBuffer) = 23;
	FragCatalogInfo FRAGGETCAT(FragXArg) = 24;
	FragDataBuffer FRAGGETDATA(FragXArg) = 25;

	NSVCProbeResult NSVC_LOCALPROBE(NSVCProbeArg) = 33;

	NsvcLookupClassResult NSVC_LOOKUPCLASS(RelnameString) = 34;
	NsvcLookupFragsResult NSVC_LOOKUPFRAGS(int) = 35;

	float OPT_GETCOST (OptimizerArg) = 41;
	
	void SCHEDFRAGMENT(SchedFragmentArg) = 42;

        RPCErrorCode BROKERRECEIVEBID(BidBuffer) = 45;
	RPCErrorCode SUBCONTRACTBROKER(BrokerArg) = 46;

	RPCErrorCode TWOPCSTART(SiteAddr) = 50;
	RPCErrorCode TWOPCPREPARE(int) = 51;
	RPCErrorCode TWOPCEND(EndXactDirective) = 52;
    } = 1;
} = 0x23232323;

program SITEMGRPROG {
    version SITEMGRVERS {
	TransmitReturn SITEMGRTRANSMITDATA(TransmitBuffer) = 1;
        RPCErrorCode CONTRACTWON(WinBuffer) = 2;
	RPCErrorCode BACKENDREADY(BackendBuffer) = 3;
	RPCErrorCode BACKENDDONE(int) = 4;
	RPCErrorCode CONTRACTLOST(ContractId) = 5;
	RPCErrorCode REQUESTFORBID(OfferBuffer) = 6;
        RPCErrorCode RECEIVESHORTOFFER(OfferBuffer) = 7;
	RPCErrorCode SUBBROKERDONE(BrokerAnswer) = 8;

	void CP_TOGGLE(void) = 9;
	RPCErrorCode CP_SCHEDULESTREAM(UpdateContractInfo) = 10;
	RPCErrorCode CP_UNSCHEDULESTREAM(int) = 11;
	RPCErrorCode CP_UPDATETRANSFERSETUP(SiteAddr) = 12;
	RPCErrorCode CALLCANCELCONTRACT(int) = 13;

	NsvcLookupClassResult NSVC_SITEMGRLOOKUPCLASS(RelnameString) = 101;
	NsvcLookupFragsResult NSVC_SITEMGRLOOKUPFRAGS(int) = 102;
	TupleArrayArray NSVC_POLL(NSVCPollList) = 14;
	RPCErrorCode NSVC_PROPAGATE(NSVCItem) = 15;

	/* we should get rid of this one */
	void NSVC_SITEMGRUPDATE(NSVCUpdate) = 99;

	void SCHED_SUBMIT_QUERY(SchedArg) = 1001;
	Node_list SCHED_GET_NEXT_SQ(int) = 1002;
	void SCHED_SQ_DONE(int) = 1003;

	void TELLLOST(int) = 1010;
	void DATABROKER(DataBrokerArg) = 1011;

    } = 1;
} = 0x24242424;

program NAMESVRPROG {
    version NAMESVRVERS {
	NSVCProbeResult NSVC_GLOBALPROBE(NSVCProbeArg) = 1;
	RPCErrorCode NSVC_UPDATENAMESVR(NSVCItem) = 2;
	TupleArray NSVC_SEARCH(NSVCSearchList) = 3;
    } = 1;
} = 0x25252525;

%/*program BROKERPROG {
% *    version BROKERVERS {
% *	void BROKER(BrokerArg) = 1;
% *        RPCErrorCode BROKERRECEIVEBID(BidBuffer) = 2;
% *	void SUBCONTRACTWON(int) = 3;
% *	void SUBCONTRACTLOST(int) = 4;
% *    } = 1;
%} = 0x26262626;
%*/

%/*program DATABROKERPROG {
% *   version DATABROKERVERS {
% *       void DATABROKER(int) = 1;
% *   } = 1;
%} = 0x27272727;
%*/

#ifdef RPC_HDR
%
%void rpcServerLoop(void);
%
%
%/*
% * the stuff below is a hack for mariposa hackers to debug individual
% * systems on the same machine. This should be removed before general
% * distribution.
% *
% * New Note!
% * SITEMGRPROG program id = 0x24000000 + (getuid() % 500) * 1000 + hostid
% *
% * I changed the SITEMGRPROG definition to incorporate part of the hash-type
% * function that now also includes hostid to help uniquely address sitemgrs
% * running on the same machine w/ same user. Modding getuid() by 500 and
% * multiplying by a 1000 should make it higher-order than the hostid.
% * Now, whoever uses SITEMGRPROG must add the correct hostid to it, to
% * address one of the running sitemgrs!		-Rex 3.29.1995
% */
%#undef EXECPROG
%#define EXECPROG ((u_int)(0x23000000+getuid()))
%#undef SITEMGRPROG
%#define SITEMGRPROG ((u_int)(0x24000000+(getuid()%500)*1000))
%#undef NAMESVRPROG
%#define NAMESVRPROG ((u_int)(0x25000000+getuid()))
%#undef BROKERPROG
%#define BROKERPROG ((u_int)(0x26000000+(getuid()%500)*1000))
%#undef DATABROKERPROG
%#define DATABROKERPROG ((u_int)(0x27000000+(getuid()%500)*1000))
%
%#endif
#endif
