/*-------------------------------------------------------------------------
 *
 * nameserver.h--
 *    Separate header file for the name server so that namesvc.x is
 *    not overloaded.
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 * $Id: nameserver.h,v 1.2 1995/04/24 18:58:53 andrew Exp $
 *
 *-------------------------------------------------------------------------
 */

#include "namesvc.h"
#include "access/htup.h"
#include <pthread.h>

extern pthread_mutex_t namesvrWakeupLock;
extern pthread_cond_t namesvrWakeupMainThread;

extern void NSVC_GlobalProbe(void *);
extern void NSVC_UpdateNamesvr(void *);
extern void NSVC_Poll(void *);
extern void NSVC_Propagate(void *);

extern void discoverClass(Oid classOid, NSVCProbeResult *result);
extern void updateNamesvr(Oid classOid, HeapTuple item, RPCErrorCode *result);

extern void BootstrapNamesvr(void);

/* wrappers for RPC calls to nameserver */
extern RPCErrorCode callUpdateNamesvr(NSVCItem *item);
extern NSVCProbeResult *callNsvcGlobalProbe(NSVCProbeArg *probeArg);


/* 
 * names and addresses of sites this name server knows about -
 * initialized from a file passed by "postgres -n <filename>"
 */

extern char **NSVC_SiteNames;
extern int *NSVC_SiteAddrs;
extern int NSVC_NumSites;
extern char NSVC_SiteListFileName[];

/*
 * variables used by all mariposa processes
 */

extern char *NamesvrSiteName; /* sitename of the global namesvr to contact */
extern int NamesvrSiteAddr;   /* address of the global namesvr to contact */
extern int mariposaNamesvr;   /* is this process a namesvr? */

#define NSVRSITE_VARNAME "NAMESVRSITE"

typedef struct NSVC_class_entry {
    int nfrags;
    HeapTuple class;
    HeapTuple *frags;
} NSVC_ClassEntry;
