/*-------------------------------------------------------------------------
 *
 * namesvc.x--
 *    RPC protocol for name service
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 * $Id: namesvc.x,v 1.11 1995/11/18 01:32:51 jsidell Exp $
 *
 *-------------------------------------------------------------------------
 */
#ifdef RPC_HDR
%#ifndef NAMESVC_H
%#define NAMESVC_H
%
%#include <rpc/rpc.h>
%#include <rpc/types.h>
%#include <sys/socket.h>
%#include <netdb.h>
%#include "exchange.h"
%#include "queries.h"	/* for SiteAddrList */
%#include "rpctypes.h"
#endif

enum NSVCAction {
    NSVC_FINDLOCALFRAG,
    NSVC_TAKEINVENTORY,
    NSVC_DISCOVERCLASS,
    NSVC_FINDPGHOSTS,
    NSVC_SCHEDGETFRAGINFO  /* called by scheduler to get info about a fragment */
};

enum NSVCFragmentSpec {
    ANY,
    MASTER
}; /* To tell us if we are referring to any copy or specifically the master. */

struct NSVCProbeArg {
    NSVCAction action;		/* what to do? */
    NSVCFragmentSpec fspec;	/* Looking for any ole' copy or the master? */
    int oid;			/* Oid of class or fragment */
};

struct NSVCProbeResult {
    RPCErrorCode error;
    bool	found;
    int 	fragids<>;
    TupleArrayArray classes;
    SiteAddrList pgsites;
};

struct NSVCSearchArg {
    int cacheId;
    opaque keys<>;
};

struct NSVCUpdate {
    int		action;		/* 1=departed, 2=arrived */
    int		frastoreid;
};

typedef NSVCSearchArg NSVCSearchList<>;

/* we will eventually want to allow constraints in the poll arguments */
struct NSVCPollArg {
    int classId;
};

typedef NSVCPollArg NSVCPollList<>;

struct NSVCItem {
    int classId;
    Tuple tuple;
};

#ifdef RPC_HDR
%
%extern NSVCProbeResult *
%NsvcLocalProbe(NSVCProbeArg *arg);
%
%extern void handleCall_NSVC_LOCALPROBE(void *arg);
%extern void handleCall_FRAGIDS(void *args);
%extern void handleCall_CLASSES(void *args);
%
%extern SiteAddrList *findPgHosts(void);
%#endif	/* NAMESVC_H */
#endif
