/*-------------------------------------------------------------------------
 *
 * namesvc.c--
 *    name service related RPC calls in the sitemgr
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *    $Header: /usr/local/devel/mariposa/cvs/src/backend/rpc/namesvc_sm.c,v 1.3 1995/04/24 18:58:57 andrew Exp $
 *
 *-------------------------------------------------------------------------
 */
#include <pthread.h>
#include <rpc/types.h>
#include "utils/elog.h"
#include "mariposa_rpc.h" /* for procedure constants */
#include "rpc/rpcutils.h"

#include "sitemgr/rpcerror.h"

void
NSVC_Poll(void *args)
{
    char **argv = (char **)args;
    NSVCPollList *arg = (NSVCPollList *)argv[0];
    SVCXPRT *transp = (SVCXPRT *)argv[1];
    TupleArrayArray result;
    NSVCProbeArg probeArg;
    NSVCProbeResult *probeResult;

    probeArg.action = NSVC_TAKEINVENTORY;
    probeResult = (NSVCProbeResult *)
	invokeExec(NSVC_LOCALPROBE, &probeArg, -1, "NSVC_Poll");
    result = probeResult->classes;

    if (!svc_sendreply(transp, xdr_TupleArrayArray, &result)) {
	elog(NOTICE, "NSVC_Poll: svc_sendreply failed\n");
    }
}

void
NSVC_Propagate(void *args)
{
    char **argv = (char **)args;
    NSVCItem *item = (NSVCItem *)argv[0];
    SVCXPRT *transp = (SVCXPRT *)argv[1];
    RPCErrorCode result;

    /* DO NOTHING FOR NOW - THIS WILL TRAP INTO THE RULE SYSTEM */
    result = SUCCESS;

    if (!svc_sendreply(transp, xdr_RPCErrorCode, &result)) {
	elog(NOTICE, "NSVC_Propagate: svc_sendreply failed\n");
    }
}
