/*-------------------------------------------------------------------------
 *
 * schedRPC.c--
 *    scheduler related RPC calls.
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *    $Header: /usr/local/devel/mariposa/cvs/src/backend/rpc/schedRPC.c,v 1.3 1995/04/24 18:59:08 andrew Exp $
 *
 *-------------------------------------------------------------------------
 */
#include <rpc/types.h>
#include <pthread.h>
#include "utils/elog.h"
#include "mariposa_rpc.h" /* for procedure constants */
#include "rpc/rpcutils.h"

#include "rpc/call_exec.h" /* backend calling facility */

/*
 * schedulerSubmitQueries --
 *	wrapper for RPC call
 *
 *	creates and destroys client handle
 */
void 
schedulerSubmitQuery(int pid, void * list)
{
    RpcConn *rpcc;
    SchedArg schedArg;

    schedArg.pid = pid;
    schedArg.list = list;

    rpcc =
	Rpc_connectSitemgr(getMyHostId(), 0,
			   "schedulerSubmitQueries", RPC_ONERR_WARN);

    Rpc_call(rpcc, RPC_SCHED_SUBMIT_QUERY, &schedArg, NULL);

    Rpc_disconnect(rpcc);
}


/*
 * schedulerGetNextSQ --
 *	wrapper for RPC call
 *
 *	creates and destroys client handle
 */
void
schedulerGetNextSQ(int pid, Node_list *list)
{
    RpcConn *rpcc;

    rpcc =
	Rpc_connectSitemgr(getMyHostId(), 0,
			   "schedulerGetNext", RPC_ONERR_WARN);

    Rpc_call(rpcc, RPC_SCHED_GET_NEXT_SQ, &pid, list);
    Rpc_disconnect(rpcc);
}

/*
 * schedulerSQDone --
 *	wrapper for RPC call
 *
 *	creates and destroys client handle
 */
void 
schedulerDoneSQ(int pid)
{
    RpcConn *rpcc;

    rpcc =
	Rpc_connectSitemgr(getMyHostId(), 0,
			   "schedulerDoneSQ", RPC_ONERR_WARN);

    Rpc_call(rpcc, RPC_SCHED_SQ_DONE, &pid, NULL);

    Rpc_disconnect(rpcc);
}



