/*-------------------------------------------------------------------------
 *
 * datafrag.x--
 *    RPC protocol for handling data fragments (eg. movement)
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 * $Id: syncFrag.x,v 1.3 1995/09/23 06:50:12 searcher Exp $
 *
 *-------------------------------------------------------------------------
 */
#ifdef RPC_HDR
%#ifndef SYNCFRAG_H
%#define SYNCFRAG_H
%
%#include <rpc/rpc.h>
%#include <rpc/types.h>
%#include <sys/socket.h>
%#include <netdb.h>
%#include "exchange.h"
%#include "rpctypes.h"
#endif

struct SyncFragmentResult {
    RPCErrorCode error;
};

struct SyncFragmentArg {
    int bidCollIndex;		/* Bid collection on the receiving side */
    ContractId contract;        /* Contract ID on the sending side */
    SiteAddr sender;		/* address for direct contact */
    SiteAddr receiver;          /* ditto                      */
    int frastoreid;		/* Oid of fragment to be moved */
    int fraclassid;		/* laziness (should do catalog look up) */
};

#ifdef RPC_HDR
%
%extern void handleCall_SYNCPUTFRAGMENT(void *args);
%extern void handleCall_SYNCGETFRAGMENT(void *args);
%
%#endif	/* DATAFRAG_H */
#endif
