/*-------------------------------------------------------------------------
 *
 * twopc.x--
 *    Routine declarations to support a two-phase commit protocol in Mariposa.
 *
 * Copyright (c) 1995, Regents of the University of California
 *
 * $Id: twopc.x,v 1.1 1996/01/28 00:35:47 searcher Exp $
 *
 *-------------------------------------------------------------------------
 */
#ifdef RPC_HDR
%#ifndef TWOPC_H
%#define TWOPC_H
%#include "postgres.h"
%#include "rpctypes.h"
%
#endif

/*
 * For ending a two phase commit transaction, tells participating site
 * what to do.
 */
enum EndXactDirective {
    ABORTXACT,
    COMMITXACT
};

#ifdef RPC_HDR
%
%/*
% * Backend routines used from coordinator site.
% */
%extern void StartRemoteSite(void *rpcc, int xactid);
%extern void AbortRemoteSite(void *rpcc, int xactid);
%extern void CommitRemoteSite(void *rpcc, int xactid);
%
%/*
% * Remote site backend routines.
% */
%extern void handleCall_TWOPCSTART(void *arg);
%extern void handleCall_TWOPCPREPARE(void *arg);
%extern void handleCall_TWOPCEND(void *arg);
%
%#endif	/* TWOPC_H */
#endif





