#include <stdio.h>
#include "parameter.h"
#include "listSched.h"

typedef struct {
    ElemType * next;
    int num;
} LruEntryType;

typedef struct {
    ListX lruList;
    LruEntryType * ptrArray;
    int size;
} LruHandle;


LruHandle *
LruInit_SS (size)
int size;
{
    int i;
    
    LruHandle * handle = (LruHandle *) 
	MallocErrorCheck(sizeof(LruHandle));

    handle->ptrArray = (LruEntryType *) MallocErrorCheck 
	(size*sizeof(LruEntryType));

    for (i = 0; i < size; i++) {
	handle->ptrArray[i].num = i;
    }
    
    handle->size = size;

    InitList (&(handle->lruList));

    return handle;
}

LruAccess_SS(handle, num)
LruHandle * handle;
int num;
{
    Element * ptr;
    
    ptr = (Element *) &(handle->ptrArray[num]);
    RemoveGivenElfromList (&(handle->lruList), ptr);
    AddEltoList (&(handle->lruList), ptr);
    if (is_debug("u")) {
	printf ("LruAccess  %d\n", num);
    }
}


LruEntry_SS (handle)
LruHandle * handle;
{

    LruEntryType * ptr;

    ptr = (LruEntryType *) RemoveElfromList (&(handle->lruList));
    if (ptr == NULL) return (0);
    if (is_debug("u")) {
	printf ("LruEntry  %d\n", ptr->num);
    }
    return (ptr->num);
}


