#include <stdio.h>
#include <math.h>
#include "parameter.h"
#include "listSched.h"
#include "querySched.h"

extern double drand48(), log();

/*
 * non-static globals
 */
int avgSel;

static int accessFreq = 80;
static int relsFreq = 20;
static char ** taskQ;
static int freqRels, * randomRel;
static int totalQueriesSubmitted;
static ListX freeQueryList;

float SS_QueryCost PROTO((QueryPtr query));
int SS_JoinQuery PROTO((QueryPtr query));
char * GetQuery PROTO((int user));
void PrintQueryStruct PROTO((QueryPtr query));
QueryPtr AllocQueryStruct PROTO((void));
void ReleaseQueryStruct PROTO((QueryPtr queryPtr));
void QueryDone PROTO((QueryPtr query));
void SS_InitQueries PROTO((void));

static int ARandomRelation PROTO((void));
static void GetAQuery PROTO((QueryPtr q));
static void PermuteRelations PROTO((void));


/*----------------------------------------------------------------
 * SS_InitQueries() ---
 *   initialize event queue with the first query from each of the
 *   NUM_USER users.
 */

void
SS_InitQueries()
{
    InitList (&freeQueryList);
}

/*---------------------------------------------------------------
 * Interface routines to the query data structure
 */


char *
GetQuery(user)
int user;
{
    return (taskQ[user]);
}

float
ArrivalTime(query)
QueryPtr query;
{
    return (query->arr_time);
}

int
GetUser(query)
QueryPtr query;
{
    return (query->user);
}

float
SS_QueryCost(query)
QueryPtr query;
{
    return (query->cost);
}


int SS_JoinQuery(query)
QueryPtr query;
{
    return(query->rel[1] != -1);
}

GetAvgSel()
{
    avgSel = seqScanPercent + 0.15*(100-seqScanPercent);
    return avgSel;
}

QueryPtr
AllocQueryStruct()
{
    QueryPtr queryPtr;

    queryPtr = (QueryPtr) RemoveElfromList(&freeQueryList);

    if (queryPtr == NULL) {
	queryPtr = (QueryPtr) MallocErrorCheck (sizeof(QueryData));
    }
    return (queryPtr);
}

void
ReleaseQueryStruct(queryPtr)
QueryPtr queryPtr;
{
    AddEltoList (&freeQueryList, (ElemType *) queryPtr);
}

void
PrintQueryStruct(queryPtr)
QueryPtr queryPtr;
{
    printf ("C: %7.1f U: %3d R0: %3d R1: %3d %f \n", queryPtr->cost, 
	    queryPtr->user, queryPtr->rel[0], queryPtr->rel[1], 
	    queryPtr->arr_time);
}


GetUniformRandom(n)
int n;
{
    if (n == 0) return n;
    return (rand() % n);
}

