/*
 * Each logical relation is divided into fragments based on size and
 * layout constraints as described in relation.c
 */
typedef struct LogicalRelInfo
{
    int relid;
    int size;
    ListX layout;         /* layout of relation on perplatter basis */
    int fragmentStart;    /* 'relid' of first fragment */
    int fragmentEnd;      /* 'relid' of last fragment  */
                          /* the fragments into which the relation is divided 
			     have relids between above two numbers */
} LogicalRelData, * LogicalRelPtr;

/*
 * The layout information for a relation is stored on a per platter basis.
 * the 'layout' field is a list of 'LayoutInfo'. Each LayoutInfo structure
 * stores the size of the relation sub-part stored on platter 'plat'.
 */
typedef struct 
{
    Element * next;
    int size;
    int plat;
    int startBlock;
} LayoutInfo;

struct RelInfo
{
    int relid;
    int size;              /* relation size */
    int plat;              /* platter on which the relation is stored*/
    int startBlock;        /* starting position on platter */
    int numBlocks;         /* size in number of blocks     */
};
typedef struct RelInfo RelData;
typedef struct RelInfo * RelPtr;

extern RelData relList[NUM_RELS];

int RelSize PROTO((int i));
int RelPlatName PROTO((int rel));
int RelNumBlocks PROTO((int rel));
int RelStartBlock PROTO((int rel));
void GenerateRelation PROTO((void));
