/*-----------------------------------------------------------------
 * sim.c --
 *   The event driven simulator loop.
 */

#include "stdio.h"
#include "parameter.h"
#include "pg-interface.h"

/*
 * Each token should get a unique id - otherwise the simulator just
 * over-writes the old token with the same id!!
 */

void
MainLoop()
{
    char * current_attr;
    int event;

    while ( ! StoppingCriteria() )
    {
	/* get next simulation event */
        NextEvent(&event, &current_attr);
        switch(event)
        {
	case EVENT__SUBMIT_QUERY :
	    if (is_debug("e")) 
		printf("\nEVENT__SUBMIT_QUERY\n");
	    HandleArrivingQuery(RegisterArrivingQuery(current_attr),
				MyTime());
	    SubmitJobs();
	    break;

	case EVENT__PROCESS_QUERY :
	    if (is_debug("e")) 
		printf("EVENT__EXECUTE_QUERY \n");
	    CPUJobDone(current_attr);
	    HandleFinishedQuery (current_attr, MyTime());
	    break;

	case EVENT__CACHE_REL:
	    if (is_debug("e"))
		printf("EVENT__CACHE_REL \n");
	    IOJobDone(current_attr);
	    break;

	case EVENT__UNCACHE_REL:
	    if (is_debug("e"))
		printf("EVENT__UNCACHE_REL \n");
	    SubmitJobs();
	    break;

	default:
	    PrintError("illegal event"); 
	}
    }
    PrintAllStatx(MyTime());
}

void
SS_SubmitQuery (char * arg)
{
    EventSchedule (EVENT__SUBMIT_QUERY, arg, 0);
}

void
SS_CacheRelDone (char * token)
{
    EventSchedule (EVENT__CACHE_REL, token, 0);
}


void
SS_UnCacheRelDone ()
{
    EventSchedule (EVENT__UNCACHE_REL, NULL, 0);
}

SS_QueryDone(char * queryPtr)
{
    EventSchedule (EVENT__PROCESS_QUERY, queryPtr, 0);    
}





