#include <stdio.h>
#include "parameter.h"

extern char outputFormat;

int statxNumSwitches = 0;
float statxIOTime = 0.0;
float statxferTime = 0.0;
float statxProcessing = 0.0;
float statxSwitchTime = 0.0;
float statxSeekVar    = 0.0;
float statxWastedIOTime = 0.0;
float statxSharedAccess = 0;
float statxUnsharedAccess = 0;
float statxCumResponse = 0.0; 
int statxCacheHits = 0;
int statxQryIn=0;
int statxQryOut=0;
int statxRelsCached=0;

extern char * GetRobotName();
/*----------------------------------------------------------------
 */
void
PrintAllStatx(curr_time)
float curr_time;
{
    if (outputFormat == 'd') {
	printf("\n------------------------");
	printf("\n Simulation time : %f", curr_time);
	PrintQueryStatx(curr_time);
	PrintIOStatx(curr_time);
	PrintCacheStatx();
	printf("\n-----------------------\n");
    } else {
	PrintQueryStatx(curr_time);
	PrintIOStatx(curr_time);
    }

}


PrintQueryStatx (curr_time)
float curr_time;
{
    int totalQueriesMeasrd;
    float totTime;

    totalQueriesMeasrd = endMeasurement - startMeasurement;
    if (detectMean) return;

    switch (outputFormat) {
    case 'r':
	printf("%f\n",(float)statxCumResponse/totalQueriesMeasrd);
	return;
    case 't':
	printf("%f\n",curr_time);
	return;
    case 'p':
	printf ("%d\n", statxNumSwitches);
	break;
    case 'n':
	printf("%d\n", numPlats);
	break;
    case 'i':
	printf ("%.2f\n", statxIOTime);
	break;
    case 'x':
	printf ("%.2f\n", statxferTime);
	break;
    case 's':
	printf ("%s: switch %.2f s, transfer per MB %.2f s\n", 
		GetRobotName(), switchTime, tertWeight);
	break;
    case 'h':
	break;
    default:
	printf("\n Avg response time : %f", 
	       statxCumResponse/totalQueriesMeasrd);
	totTime = statxProcessing + statxIOTime;
	printf("\n Overlap: %f  CPU: %f %.2f IO: %.2f %.2f", 
	       totTime - curr_time, 
	       statxProcessing, statxProcessing/totTime,
	       statxIOTime, statxIOTime/totTime);
	
	printf("\n Number of queries : %d", totalQueriesMeasrd);
	if (!QueryOriented()) {
	    printf("\n Avg #Q/rel cached : %.1f, fraction Qry done %.2f", 
		   (float) statxQryIn/(float)statxRelsCached,
		   (float)(statxQryIn - statxQryOut)/(float)statxQryIn);
	}
	printf ("\n Number of platters %d", numPlats);
	printf ("\n Max Fragment Size %d", maxFragmentSize);
	break;
    }
}


PrintIOStatx (totTime)
float totTime; 
{ 
    float seekTime;
    float totSwtchTime = (float)statxNumSwitches*switchTime;

    seekTime = statxIOTime - totSwtchTime - statxferTime;

    switch (outputFormat) {
    case 'h':
	totTime = statxProcessing + statxIOTime;
	printf("%.2f\t%.2f\t%.2f\t%.2f\t%.2f\t%.2f\n", 
	       statxProcessing*100/totTime,
	       statxIOTime*100/totTime,
	       statxferTime*100/statxIOTime,
	       totSwtchTime*100/statxIOTime,
	       seekTime*100/statxIOTime,
	       statxSeekVar*100/statxIOTime
	       );
	break;
    case 'd':
	printf ("\n NumSwitches = %d", statxNumSwitches);
	printf ("\n IO xfr: %.2f %.2f switch %.2f %.2f seek: %.2f %.2f %.2f %.2f",
		statxferTime, statxferTime/statxIOTime,
		totSwtchTime, totSwtchTime/statxIOTime,
		seekTime, seekTime/statxIOTime,
		statxSeekVar,
		(statxSeekVar)/statxIOTime);
	
	printf ("\n Wasted IO time = %.2f s, %.2f", statxWastedIOTime, 
		statxWastedIOTime/statxIOTime);
	printf ("\n total shared data = %f s, total data = %f s", 
		statxSharedAccess, statxUnsharedAccess);
	printf ("\n CPU weights: fixed %.2f var single %.2f join %.2f", 
		fixedCost, costWeight, joinWeight);  
	printf("\n IO weight: fixed %.2f var %.2f, SwtchTime: %.2f\n", 
	       tertFixedCost, tertWeight, switchTime);
    }
}

PrintCacheStatx()
{
    printf ("\n Number of hits in unpinned cache %d", statxCacheHits);
}

float
StatxEstimateAccessTime(size)
int size;        /* size in SIZE_UNIT */
{
    return (tertWeight*size);
}







