###########################################################################
# databroker.tcl--
#
#
# Copyright (c) 1994, Regents of the University of California
#
#
# IDENTIFICATION
#    $Header: /usr/local/devel/mariposa/cvs/src/backend/sitemgr/databroker.tcl,v 1.1 1996/06/15 01:48:11 am Exp $
#
###########################################################################

set fragmentsAccessed ""

proc DataBroker {} {
    global fragments
    global hostid
    global fragmentsAccessed

    puts stderr "DataBroker"
    puts stderr "fragments = $fragments"
    puts stderr "my hostid = $hostid"
    puts stderr "fragments accessed: $fragmentsAccessed"

    flush stderr

    # Go through each fragment in the list of fragments
    # accessed.  If a fragment has been accessed twice
    # then buy it.
    # 
    # Use the fragment's logicalid to keep track of which
    # fragments have been accessed.  Logicalid's are unique
    # across sites but are the same for copies of the same
    # fragment.

    foreach fragment $fragments {
puts stderr "checking fragment $fragment"
    flush stderr

	set fraStorageSites [lindex $fragment 5]
	if {[lsearch $fraStorageSites $hostid] == -1} {
puts stderr "Not local"
flush stderr
	    set fralogicalid [lindex $fragment 1]
	    set listPos [lsearch $fragmentsAccessed $fralogicalid]
	    if {$listPos > -1} {
puts stderr "Already accessed once - buy it"
flush stderr
		set fragmentsAccessed [lreplace $fragmentsAccessed $listPos $listPos]
		set fraclassid [lindex $fragment 0]
		set frastoreid [lindex $fragment 2]
		set frahostid [lindex $fraStorageSites 0]
		takefragment $fraclassid $frastoreid $frahostid
	    } else {
puts stderr "Not accessed yet.  Recording."
flush stderr
		lappend fragmentsAccessed $fralogicalid
	    }
	} else {
puts stderr "Local."
flush stderr
	}
    }


}

