/*-------------------------------------------------------------------------
 *
 * rpcerror.h--
 *    Message codes for rpc generated errors.
 *    By convention, 0 indicates successful completion,
 *    positive values indicate failure within the natural course
 *    of execution, and negative values indicate errors.
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 * $Id: rpcerror.h,v 1.5 1996/01/27 19:41:55 rp2y Exp $
 *
 *-------------------------------------------------------------------------
 */

#ifndef RPCERROR_H
#define RPCERROR_H

#define SUCCESS		     	0

#define ARGUMENT_OUTOFRANGE 	-101
#define BAD_PROTOCOL		-102
#define UNRECOGNIZED_CONTRACT	-103
#define UNRECOGNIZED_ACTION	-104
#define NOT_YET_IMPLEMENTED	-105
#define EXECUTION_ERROR		-106

#define SERVICE_REFUSED	     	101
#define CLASS_UNKNOWN		102

#endif /* RPCERROR_H */

