/*-------------------------------------------------------------------------
 *
 * sitemgr.h--
 *    
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 * $Id: sitemgr.h,v 1.12 1996/06/14 20:23:30 jsidell Exp $
 *
 *-------------------------------------------------------------------------
 */
#ifndef SITEMGR_H
#define SITEMGR_H
#include "postgres.h"
#include "rpctypes.h"
#include "bid.h"
#include "sitemgr/execs.h"
#include "queries.h"
#include "datafrag.h"
#include <netinet/in.h>
#include <pthread.h>
#include "namesvc.h"
#include "nodes/plannodes.h"
#include "nodes/pg_list.h"
#include "tcl.h"

/*
 * in sitemgr/sitemgr.c
 */

/* lock and signals */
extern pthread_mutex_t execsLock;
extern pthread_mutex_t bidderLock;
extern pthread_mutex_t bidLock;
extern pthread_mutex_t updateStreamQueueLock;
extern pthread_cond_t bidAvailable;
extern pthread_cond_t execAvailableCond;
extern pthread_cond_t execAssignedCond;

extern void *invokeExec(int rpcproc, void *args, int qepFragId, 
			 char *funcname);
extern bool isLocalFragment(Oid oid, NSVCFragmentSpec fspec);
extern SiteAddrList *clnt_findPgHosts(void);

/*
 * in sitemgr/sitemgrrpc.c
 */
extern void ContractWon(void *);
extern void ReceiveOffer(void *);
extern void Cp_UpdateTransferSetup(void *);
extern void TransmitData(void *);
extern void LookupClass(void *);
extern void LookupFrags(void *);
extern void BackendReady(void *);
extern void BackendDone(void *);
extern void ReceiveRequestForBid(void *);
extern void ContractLost(void *);
extern void TellLost(void *);
extern void DataBroker(void *);

/*
 * in sitemgr/slog.c
 */
extern void sitemgrDebug(int lev, char *fmt, ...);
extern void sitemgrLogEvent(char *message, ...);


/*
 * in sitemgr/subcontract.c
 */
int SubContract(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[]);
void SubBrokerDone(void *args);

#endif	/* SITEMGR_H */

