/*-------------------------------------------------------------------------
 *
 * slog.c--
 *    routines for outputting debugging and logging messages
 *
 * Copyright (c) 1994-5, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *    $Header: /usr/local/devel/mariposa/cvs/src/backend/sitemgr/slog.c,v 1.4 1996/03/04 09:07:15 aoki Exp $
 *
 *-------------------------------------------------------------------------
 */
#include <stdio.h>
#include <stdarg.h>
#include "namesvc.h"
#include "sitemgr/sitemgr.h"

short DebugLvl;	
FILE *eventsFile = NULL;	/* for the sitemgr monitor GUI */

/*
 * sitemgr_debug --
 *	Debugging printout for sitemgr
 */
void
sitemgrDebug(int lev, char *fmt, ...)
{
    va_list ap;
    static int pid = -1;
    
    if (lev <= DebugLvl) {
	char s[BUFSIZ];

	va_start(ap, fmt);
	vsprintf(s, fmt, ap);
	va_end(ap);

	fprintf(stderr, "%5d %s", (pid < 0) ? (pid = getpid()) : pid, s);
    }
}

/*****************************************************************************
 *
 *****************************************************************************/

void
initEventsFile(char *fname)
{    
    if ((eventsFile = fopen(fname,"w"))==NULL) {
	fprintf(stderr, "sitemgr: cannot open \"%s\" for writing\n",
		fname);
    }
}

/*
 * -------------------------------------------------------------------
 * sitemgrLogEvent -
 *   log events to the specified file. The messages actually are tcl
 *   commands to drive the sitemgr monitor GUI.
 * -------------------------------------------------------------------
 */
void
sitemgrLogEvent(char *message, ...)
{
    va_list ap;
    
    if (eventsFile == NULL)
	return;

    va_start(ap, message);
    vfprintf(eventsFile, message, ap);
    fprintf(eventsFile, "\n");
    fflush(eventsFile);
    va_end(ap);
}

