/*-------------------------------------------------------------------------
 *
 * smgr.h--
 *    storage manager switch public interface declarations.
 *
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 * $Id: smgr.h,v 0.5 1996/06/07 04:59:33 am Exp $
 *
 *-------------------------------------------------------------------------
 */
#ifndef SMGR_H
#define SMGR_H

#include "utils/rel.h"
#include "storage/spin.h"	/* for SPINLOCK */

#define SM_FAIL		0
#define	SM_SUCCESS	1

#define	DEFAULT_SMGR	0

extern int smgrinit(void);
extern void smgrshutdown(int dummy);
extern int smgrcreate(int16 which, Relation reln);
extern int smgrunlink(int16 which, Relation reln);
extern int smgrextend(int16 which, Relation reln, char *buffer);
extern int smgropen(int16 which, Relation reln);
extern int smgrclose(int16 which, Relation reln);
extern int smgrread(int16 which, Relation reln, BlockNumber blocknum,
		    char *buffer);
extern int smgrwrite(int16 which, Relation reln, BlockNumber blocknum,
		     char *buffer);
extern int smgrflush(int16 which, Relation reln, BlockNumber blocknum,
		     char *buffer);
#ifndef P95
extern int smgrblindwrt(int16 which, Name dbname, Name relname, Oid dbid,
			Oid relid, BlockNumber blkno, Size blocksz,
			char *buffer);
#else /* P95 */
extern int smgrblindwrt(int16 which, char *dbname, char *relname, Oid dbid,
			Oid relid, BlockNumber blkno, char *buffer);
#endif /* P95 */
extern int smgrnblocks(int16 which, Relation reln);
extern int smgrcommit(void);
extern int smgrabort(void);
extern bool smgriswo(int16 smgrno);
#ifndef P95
extern bool smgrisTM(int smgrno);
#endif /* P95 */


#ifdef P95

#endif /* P95 */
/* internals: move me elsewhere -- ay 7/94 */

/* in md.c */
extern int mdinit(void);
extern int mdcreate(Relation reln);
extern int mdunlink(Relation reln);
extern int mdextend(Relation reln, char *buffer);
extern int mdopen(Relation reln);
extern int mdclose(Relation reln);
extern int mdread(Relation reln, BlockNumber blocknum, char *buffer);
extern int mdwrite(Relation reln, BlockNumber blocknum, char *buffer);
extern int mdflush(Relation reln, BlockNumber blocknum, char *buffer);
extern int mdblindwrt(char *dbstr, char *relstr, Oid dbid, Oid relid,
#ifndef P95
		      BlockNumber blkno, Size blocksz, char *buffer);
#else /* P95 */
		      BlockNumber blkno, char *buffer);
#endif /* P95 */
extern int mdnblocks(Relation reln);
extern int mdcommit(void);
extern int mdabort(void);

#ifndef P95

#ifdef MAIN_MEMORY 
#endif /* P95 */
/* mm.c */
#ifdef P95
extern SPINLOCK MMCacheLock;
#endif /* P95 */

#ifndef P95
#define MMNBUFFERS	10
#define MMNRELATIONS	2

#endif /* P95 */
extern int mminit(void);
extern int mmshutdown(void);
extern int mmcreate(Relation reln);
extern int mmunlink(Relation reln);
extern int mmextend(Relation reln, char *buffer);
extern int mmopen(Relation reln);
extern int mmclose(Relation reln);
extern int mmread(Relation reln, BlockNumber blocknum, char *buffer);
extern int mmwrite(Relation reln, BlockNumber blocknum, char *buffer);
extern int mmflush(Relation reln, BlockNumber blocknum, char *buffer);
extern int mmblindwrt(char *dbstr, char *relstr, Oid dbid, Oid relid,
#ifndef P95
		      BlockNumber blkno, Size blocksz, char *buffer);
#else /* P95 */
		      BlockNumber blkno, char *buffer);
#endif /* P95 */
extern int mmnblocks(Relation reln);
extern int mmcommit(void);
extern int mmabort(void);
extern int MMShmemSize(void);
#ifndef P95
#endif
#endif /* P95 */

#ifndef P95
#ifdef HP_JUKEBOX
/* hp jukebox */
extern SPINLOCK HPCacheLock;
extern SPINLOCK JBSpinLock;

extern int hpinit(void);
extern int hpshutdown(void);
extern int hpcreate(Relation reln);
extern int hpunlink(Relation reln);
extern int hpextend(Relation reln, char *buffer);
extern int hpopen(Relation reln);
extern int hpclose(Relation reln);
extern int hpread(Relation reln, BlockNumber blocknum, char *buffer);
extern int hpwrite(Relation reln, BlockNumber blocknum, char *buffer);
extern int hpflush(Relation reln, BlockNumber blocknum, char *buffer);
extern int hpblindwrt(char *dbstr, char *relstr, Oid dbid, Oid relid,
		      BlockNumber blkno, Size blocksz, char *buffer);
extern int hpnblocks(Relation reln);
extern int hpabort(void);
extern int hpcommit(void);
extern int HPShmemSize(void);

#endif

#ifdef FRAGMENT_SMGR
extern int frcreate(Relation reln);
extern int frunlink(Relation reln);
extern int frextend(Relation reln, char *buffer);
extern int fropen(Relation reln);
extern int frclose(Relation reln);
extern int frread(Relation reln, BlockNumber blocknum, char *buffer);
extern int frwrite(Relation reln, BlockNumber blocknum, char *buffer);
extern int frflush(Relation reln, BlockNumber blocknum, char *buffer);
extern int frblindwrt(char *dbstr, char *relstr, Oid dbid, Oid relid,
		      BlockNumber blkno, Size blocksz, char *buffer);
extern int frnblocks(Relation reln);

#endif /* FRAGMENT_SMGR */

#endif /* P95 */
#endif	/* SMGR_H */
#ifndef P95




#endif /* P95 */
