/*
 *  hpaccess.c -- Access interface code for the HP magneto-optical jukebox.
 * [missing RCS id]
 */

#include "c.h"
#include "postgres.h"
#include "utils/elog.h"

#ifdef HP_JUKEBOX

#include <stdio.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <errno.h>

#include "storage/hpaccess.h"

/*
 * ----------------------------------------------------------------------
 *	main library routines
 * ----------------------------------------------------------------------
 */

/*
 * jb_init
 */
int
jb_init()
{
  return (0);
}


PLATDESC
jb_open(Name platter_id, int flags)
{
    int fd;
    char path[200];
    extern int errno;

    sprintf(path, "/private/mariposa/data/HP");	
    strcat(path, (char *)platter_id);
    fd = open (path, flags);
    if (fd == -1) {
	elog(WARN, "Error opening platter %s: errno %d\n", path, errno);
    }
    return ((PLATDESC)fd);
}


int
jb_read(int fd, char *buf, long blockno, long nblocks)
{
    int size, len;

    len = blockno*JB_BLOCK_SIZE;
    if (lseek(fd, len, SEEK_SET) != len) {
	return -1;
    }
    
    size = nblocks*JB_BLOCK_SIZE;
    if (read (fd, buf, size) != size) {
	return -1;
    }
    return (0);
}


int
jb_write(int fd, char *buf, long blockno, long nblocks)
{
    int size, len;

    len = blockno*JB_BLOCK_SIZE;
    if (lseek(fd, len, SEEK_SET) != len) {
	return -1;
    }
    
    size = nblocks*JB_BLOCK_SIZE;
    if (write (fd, buf, size) != size) {
	return -1;
    }
    return (0);
}


int
jb_close(int fd)
{
    close (fd);
    return (0);
}


int
jb_exit()
{
    return 0;
}

#endif /* HP_JUKEBOX */


