/*-------------------------------------------------------------------------
 *
 * smgr_mm.h--
 *    Main memory storage manager.
 *
 * Copyright (c) 1994-5, Regents of the University of California
 *
 * $Id: smgr_mm.h,v 1.1 1995/04/21 05:45:08 andrew Exp $
 *
 *-------------------------------------------------------------------------
 */


/*
 *  MMCacheTag -- Unique triplet for blocks stored by the main memory
 *		  storage manager.
 */

typedef struct MMCacheTag {
    Oid			mmct_dbid;
    Oid			mmct_relid;
    BlockNumber		mmct_blkno;
} MMCacheTag;

/*
 *  Shared-memory hash table for main memory relations contains
 *  entries of this form.
 */

typedef struct MMHashEntry {
    MMCacheTag		mmhe_tag;
    int			mmhe_bufno;
} MMHashEntry;

/*
 * MMRelTag -- Unique identifier for each relation that is stored in the
 *	            main-memory storage manager.
 */

typedef struct MMRelTag {
    Oid		mmrt_dbid;
    Oid		mmrt_relid;
} MMRelTag;

/*
 *  Shared-memory hash table for # blocks in main memory relations contains
 *  entries of this form.
 */

typedef struct MMRelHashEntry {
    MMRelTag		mmrhe_tag;
    int			mmrhe_nblocks;
} MMRelHashEntry;

extern int *MMCurTop;
extern int *MMCurRelno;
