/*-------------------------------------------------------------------------
 *
 * us_internals.h--
 *    MARIPOSA fragment usage statistics internal definitions
 *    (i.e., this file should never be needed except by the
 *           files in src/backend/storage/usage_stat)
 *
 *
 * Copyright (c) 1994,1995 Regents of the University of California
 * [missing RCS id]
 * $Id
 *
 *-------------------------------------------------------------------------
 */

#ifndef US_INTERNALS_H
#define US_INTERNALS

typedef struct {
    Oid key;
    SHMEM_OFFSET location;
} UsageHashTableEntry;

extern unsigned long *UsageStatInitialized;
extern unsigned long *UsageStatNumStatStructsUsed;
extern unsigned long *UsageStatHotListNumEntries;
extern HTAB *UsageStatTable;
extern UsageStatHotListEntry *UsageStatHotList;
extern UsageStatEntry *UsageStatEntryList;
extern SHMEM_OFFSET *UsageStatEntryListHead;
extern SHMEM_OFFSET *UsageStatEntryListTail;

extern int localSiteHostId;

#define UsageStatAcquireExLock(x)   SpinAcquire(x)
#define UsageStatReleaseExLock(x)   SpinRelease(x)

#define STABLE_KEYSIZE           sizeof(Oid)
#define STABLE_DATASIZE          sizeof(unsigned long)
#define STABLE_NENTRIES          64
#define STABLE_SIZE              100
#define SHOTLIST_NENTRIES        8

#define USEL_UpdateEntryData(existing,new) { \
	    Assert(existing != NULL && new != NULL); \
	    if (new->siteId != 0) \
		existing->siteId = new->siteId; \
	    existing->debits += new->debits; \
	    existing->credits += new->credits; \
	    existing->numAccesses += new->numAccesses; \
	    if (new->expectedPrice != 0) \
		existing->expectedPrice = new->expectedPrice; \
	    if (new->arrivalTime != 0) \
		existing->arrivalTime = new->arrivalTime; \
	    if (new->lastAccessTime != 0) \
		existing->lastAccessTime = new->lastAccessTime; \
	    else { \
		time(&existing->lastAccessTime); \
		Assert(existing->lastAccessTime != -1); \
	    } \
	    if (new->dbName.data[0] != '\0') \
		namecpy(&(existing->dbName), &(new->dbName)); \
	}

#endif /* ! US_INTERNALS_H */
