/*-------------------------------------------------------------------------
 *
 * debug.c--
 *    tcopDebug - prints out debugging messages, depending on debug level
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *    $Header: /usr/local/devel/mariposa/cvs/src/backend/tcop/debug.c,v 1.4 1996/03/05 23:47:54 jsidell Exp $
 *
 *-------------------------------------------------------------------------
 */

#include <stdio.h>
#include <stdarg.h>
#include <pthread.h>

#include "tcop/debug.h"

/*
 * tcopDebug --
 *	Debugging printout for tcop
 */

void
tcopDebug(int lev, char *fmt, ...)
{
    va_list ap;
    static int pid = -1;
    pthread_t thisThread = pthread_self();
    int threadID = (thisThread.field1 % 100000);
    
    if (lev <= DEBUGLEVEL) {
	char s[BUFSIZ];
	
	va_start(ap, fmt);
	vsprintf(s, fmt, ap);
	va_end(ap);

	fprintf(stderr, "%5d (%5d) %s", (pid < 0) ? (pid = getpid()) : pid, threadID, s);
    }
}
