#ifndef P95
/*-------------------------------------------------------------------------
 *
 * pquery.h--
 *    prototypes for pquery.c.
 *
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 * $Id: pquery.h,v 0.10 1996/06/07 05:00:26 am Exp $
 *
 *-------------------------------------------------------------------------
 */
#ifndef PQUERY_H
#define PQUERY_H

#include "executor/execdesc.h"
#include "tcop/dest.h"
#include "brokerRPC.h"

extern QueryDesc *CreateQueryDesc(Query *parsetree, Plan *plantree,
				  char **argv, Oid *typev, int nargs,
				  CommandDest dest);

extern EState *CreateExecutorState();


extern void ProcessPortal(String portalName, Query *parseTree,
			  Plan *plan, EState *state, AttrInfo *attinfo, 
			  CommandDest dest);

extern void ProcessQueryDesc(QueryDesc *qd, EState *state);

extern void ProcessQuery(Query *parsetree, Plan *plan, char *argv, Oid *typev,
			 int nargs, CommandDest dest);

extern bool _enable_fragmentation_;

#endif /* PQUERY_H */
#else /* P95 */
/*-------------------------------------------------------------------------
 *
 * pquery.h--
 *    prototypes for pquery.c.
 *
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 *
 *-------------------------------------------------------------------------
 */
#ifndef PQUERY_H
#define PQUERY_H

#include "executor/execdesc.h"
#include "tcop/dest.h"

/* moved to execdesc.h 
extern QueryDesc *CreateQueryDesc(Query *parsetree, Plan *plantree,
				  CommandDest dest);

*/
extern EState *CreateExecutorState();


extern void ProcessPortal(char *portalName, Query *parseTree,
			  Plan *plan, EState *state, TupleDesc attinfo, 
			  CommandDest dest);

extern void ProcessQueryDesc(QueryDesc *queryDesc);

extern void ProcessQuery(Query *parsetree, Plan *plan, char *argv[], 
			 Oid *typev, int nargs, CommandDest dest);

#endif /* pqueryIncluded */
#endif /* P95 */
