# Mariposa makefile
ifndef P95
#-------------------------------------------------------------------------
#
# Makefile.inc--
#    Makefile for the utilities modules
#
# Copyright (c) 1994, Regents of the University of California
#
#
# IDENTIFICATION
#    $Header: /usr/local/devel/mariposa/cvs/src/backend/utils/Makefile.inc,v 0.9 1996/06/07 05:00:39 am Exp $
#
#-------------------------------------------------------------------------

utilsdir= $(CURDIR)/utils
VPATH:= $(VPATH):$(utilsdir):\
	$(utilsdir)/adt:$(utilsdir)/cache:$(utilsdir)/error:$(utilsdir)/fmgr:\
	$(utilsdir)/hash:$(utilsdir)/init:$(utilsdir)/ledger:$(utilsdir)/mmgr:\
	$(utilsdir)/plans:$(utilsdir)/sort:$(utilsdir)/time:$(utilsdir)/nameserver

SUBSRCS=
include $(utilsdir)/adt/Makefile.inc
include $(utilsdir)/cache/Makefile.inc
include $(utilsdir)/error/Makefile.inc
include $(utilsdir)/fmgr/Makefile.inc
include $(utilsdir)/hash/Makefile.inc
include $(utilsdir)/init/Makefile.inc
include $(utilsdir)/mmgr/Makefile.inc
include $(utilsdir)/plans/Makefile.inc
include $(utilsdir)/sort/Makefile.inc
include $(utilsdir)/time/Makefile.inc
include $(utilsdir)/nameserver/Makefile.inc
include $(utilsdir)/ledger/Makefile.inc
SRCS_UTILS:= $(SUBSRCS) fmgrtab.c


GENFMGRTAB= $(utilsdir)/Gen_fmgrtab.sh
GENFMGRTABFILES= fmgr.h fmgrtab.c

#
# BKIOPTS is set in ../catalog/Makefile.inc and sets the -D flags for
# the DATA(...); statements.  Hence, ../catalog/Makefile.inc had better
# get slurped in prior to this Makefile.inc, or BKIOPTS should be set
# in a higher directory level.
#
$(GENFMGRTABFILES): $(GENFMGRTAB) $(catdir)/pg_proc.h
	cd $(objdir); \
	sh $(SHOPTS) $(GENFMGRTAB) $(BKIOPTS) $(catdir)/pg_proc.h

$(objdir)/fmgrtab.o:  fmgrtab.c
	$(cc_inobjdir)

$(objdir)/fmgrtab.d:  fmgrtab.c
	$(mkdep_inobjdir)

POSTGRES_DEPEND+= ${GENFMGRTABFILES}

#
#${PROG}: ${GENFMGRTABFILES}
#

CLEANFILES+= $(GENFMGRTABFILES)

HEADERS+= acl.h array.h bit.h builtins.h catcache.h datum.h \
	dynamic_loader.h elog.h exc.h excid.h fcache.h fmgrtab.h \
	geo-decls.h hsearch.h inval.h ledger.h lselect.h lsyscache.h \
	mcxt.h memutils.h module.h nabstime.h oidcompos.h palloc.h  plans.h \
	planstring.h portal.h psort.h rel.h rel2.h relcache.h sets.h \
	syscache.h tqual.h nameserver.h
# Postgres95 makefile
else # P95
#-------------------------------------------------------------------------
#
# Makefile.inc--
#    Makefile for the utilities modules
#
# Copyright (c) 1994, Regents of the University of California
#
#
# IDENTIFICATION
#    $Header: /usr/local/devel/mariposa/cvs/src/backend/utils/Makefile.inc,v 0.9 1996/06/07 05:00:39 am Exp $
#
#-------------------------------------------------------------------------

utilsdir= $(CURDIR)/utils
VPATH:= $(VPATH):$(utilsdir):\
	$(utilsdir)/adt:$(utilsdir)/cache:$(utilsdir)/error:$(utilsdir)/fmgr:\
	$(utilsdir)/hash:$(utilsdir)/init:$(utilsdir)/mmgr:$(utilsdir)/sort:\
	$(utilsdir)/time

SUBSRCS=
include $(utilsdir)/adt/Makefile.inc
include $(utilsdir)/cache/Makefile.inc
include $(utilsdir)/error/Makefile.inc
include $(utilsdir)/fmgr/Makefile.inc
include $(utilsdir)/hash/Makefile.inc
include $(utilsdir)/init/Makefile.inc
include $(utilsdir)/mmgr/Makefile.inc
include $(utilsdir)/sort/Makefile.inc
include $(utilsdir)/time/Makefile.inc
SRCS_UTILS:= $(SUBSRCS) fmgrtab.c

GENFMGRTAB= $(utilsdir)/Gen_fmgrtab.sh
#GENFMGRTABFILES= fmgr.h fmgrtab.c
GENFMGRTABFILES= fmgrtab.c

#
# BKIOPTS is set in ../catalog/Makefile.inc and sets the -D flags for
# the DATA(...); statements.  Hence, ../catalog/Makefile.inc had better
# get slurped in prior to this Makefile.inc, or BKIOPTS should be set
# in a higher directory level.
#
$(GENFMGRTABFILES): $(GENFMGRTAB) $(catdir)/pg_proc.h
	cd $(objdir); \
	sh $(SHOPTS) $(GENFMGRTAB) $(BKIOPTS) $(catdir)/pg_proc.h

$(objdir)/fmgrtab.o:  fmgrtab.c
	$(cc_inobjdir)

POSTGRES_DEPEND+= ${GENFMGRTABFILES}

#
#${PROG}: ${GENFMGRTABFILES}
#

CLEANFILES+= $(GENFMGRTABFILES)

HEADERS+= acl.h array.h bit.h builtins.h catcache.h datum.h \
	dynamic_loader.h elog.h exc.h excid.h fcache.h fmgrtab.h \
	geo-decls.h hsearch.h inval.h lselect.h lsyscache.h mcxt.h \
	memutils.h module.h nabstime.h oidcompos.h palloc.h  \
	portal.h psort.h rel.h rel2.h relcache.h sets.h \
	syscache.h tqual.h
endif # P95
