/*-------------------------------------------------------------------------
 *
 * elog_exit.c--
 *    handles restart or exit with WARN and FATAL in the backend. (If
 *    elog is called with WARN or FATAL in the postmaster, it will just
 *    do exitpg.)
 *
 * Copyright (c) 1994-5, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *    $Header: /usr/local/devel/mariposa/cvs/src/backend/utils/error/elog_exit.c,v 1.1 1995/04/21 05:50:47 andrew Exp $
 *
 *-------------------------------------------------------------------------
 */
#include <setjmp.h>
#include "postgres.h"
#include "miscadmin.h"
#include "storage/proc.h"

void
elog_warn_exit()
{
    extern sigjmp_buf Warn_restart;

    ProcReleaseSpins(NULL);	/* get rid of spinlocks we hold */
    siglongjmp(Warn_restart, 1);
}

void
elog_fatal_exit()
{
    /*
     * Assume that if we have detected the failure we can
     * exit with a normal exit status.  This will prevent
     * the postmaster from cleaning up when it's not needed.
     */

    ProcReleaseSpins(NULL);	/* get rid of spinlocks we hold */
    ProcReleaseLocks();		/* get rid of real locks we hold */
    exitpg(0);
}
