/*-------------------------------------------------------------------------
 *
 * lselect.h--
 *    definitions for the replacement selection algorithm.
 *
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 * $Id: lselect.h,v 0.5 1996/06/07 05:00:46 am Exp $
 * 
 * [Mariposa]
 * NOTES
 *	This file is used by
 *		utils/sort/lselect.c
 *		utils/sort/psort.c
 *					-cim 6/12/90
 *	and others 			-marcel 10/13/94
 *
 *-------------------------------------------------------------------------
 */
#ifndef	LSELECT_H
#define	LSELECT_H

#include "c.h"
#include "access/htup.h"

struct	leftist {
    short	lt_dist; 	/* distance to leaf/empty node */
    short	lt_devnum; 	/* device number of tuple */
    HeapTuple	lt_tuple;
    struct	leftist	*lt_left;
    struct	leftist	*lt_right;
};

#ifndef P95
/* replaces global variables in lselect.c to make it reentrant */
typedef struct {
    TupleDesc tupDesc;
    int nKeys;
    ScanKey scanKeys;
    int *sortMem; /* needed for psort */
} LeftistContextData;
typedef LeftistContextData *LeftistContext;
#else /* P95 */
extern	struct	leftist	*Tuples;
#endif /* P95 */

#ifndef P95
extern HeapTuple gettuple(struct leftist **treep, short *devnum,
    LeftistContext context);
extern void puttuple(struct leftist **treep, HeapTuple newtuple, short devnum,
    LeftistContext context);
extern void dumptuples(FILE *file, struct leftist **treep,
    LeftistContext context);
extern int tuplecmp(HeapTuple ltup, HeapTuple rtup, LeftistContext context);
#else /* P95 */
extern struct leftist *lmerge(struct leftist *pt, struct leftist *qt);
extern HeapTuple gettuple(struct leftist **treep, short *devnum);
extern int puttuple(struct leftist **treep, HeapTuple newtuple, int devnum);
extern void dumptuples(FILE *file);
extern int tuplecmp(HeapTuple ltup, HeapTuple rtup);
#endif /* P95 */

#ifdef EBUG
#ifndef P95
extern void checktree(struct leftist *tree, LeftistContext context);
extern int checktreer(struct leftist *tree, int level, LeftistContext context);
#else /* P95 */
extern void checktree(struct leftist *tree);
extern int checktreer(struct leftist *tree, int level);
#endif /* P95 */
#endif /* EBUG */

#endif 	/* LSELECT_H */
