/*-------------------------------------------------------------------------
 *
 * lsyscache.h--
 *    
 *
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 * $Id: lsyscache.h,v 0.4 1996/06/07 05:00:46 am Exp $
 *
 *-------------------------------------------------------------------------
 */
#ifndef	LSYSCACHE_H
#define	LSYSCACHE_H

#include "access/htup.h"

#ifndef P95
extern bool op_class(Oid opid, int32 opclass);
extern Name get_attname(Oid relid, AttrNumber attnum);
extern AttrNumber get_attnum(Oid relid, Name attname);
#else /* P95 */
extern bool op_class(Oid opid, int32 opclass, Oid amopid);
extern char *get_attname(Oid relid, AttrNumber attnum);
extern AttrNumber get_attnum(Oid relid, char *attname);
#endif /* P95 */
extern Oid get_atttype(Oid relid, AttrNumber attnum);
#ifndef P95
extern bool get_attisset(Oid relid, Name attname);
#else /* P95 */
extern bool get_attisset(Oid relid, char *attname);
#endif /* P95 */
extern RegProcedure get_opcode(Oid opid);
#ifndef P95
extern NameData get_opname(Oid opid);
#else /* P95 */
extern char *get_opname(Oid opid);
#endif /* P95 */
extern bool op_mergesortable(Oid opid, Oid ltype, Oid rtype,
			     Oid *leftOp, Oid *rightOp);
extern Oid op_hashjoinable(Oid opid, Oid ltype, Oid rtype);
extern Oid get_commutator(Oid opid);
extern HeapTuple get_operator_tuple(Oid opno);
extern Oid get_negator(Oid opid);
extern RegProcedure get_oprrest(Oid opid);
extern RegProcedure get_oprjoin(Oid opid);
extern int get_relnatts(Oid relid);
#ifndef P95
extern Name get_rel_name(Oid relid);
#else /* P95 */
extern char *get_rel_name(Oid relid);
#endif /* P95 */
extern struct varlena * get_relstub(Oid relid, int no, bool *islast);
#ifndef P95
extern Oid get_ruleid(Name rulename);
#else /* P95 */
extern Oid get_ruleid(char *rulename);
#endif /* P95 */
extern Oid get_eventrelid(Oid ruleid);
extern int16 get_typlen(Oid typid);
extern char get_typalign(Oid typid);
extern bool get_typbyval(Oid typid);
extern struct varlena *get_typdefault(Oid typid);
extern char get_typtype(Oid typid);

#endif	/* LSYSCACHE_H */

