/*-------------------------------------------------------------------------
 *
 * nameserver.h--
 *    Separate header file for the backend interface of the nameserver
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 * $Id: nameserver.h,v 1.1 1996/02/21 06:59:36 marcel Exp $
 *
 *-------------------------------------------------------------------------
 */

#ifndef _NAMESERVER_H
#define _NAMESERVER_H

#include "nameserver_mk.h" /* for NsvcLookupClassResult */

extern void handleCall_NSVC_LOOKUPCLASS(void *);
/*
 * RPC handler
 */

extern NsvcLookupClassResult *nsvc_lookupClass(char *);
/*
 * Looks up pg_class and pg_attribute tuples in local and/or 
 * nameserver catalogs.
 */

extern void nsvc_freeLookupClassResult(NsvcLookupClassResult *result);
/*
 * Deallocates memory.
 */

extern void nsvc_printLookupClassResult(NsvcLookupClassResult *result);
/* 
 * Prints it to stderr. 
 */

extern void handleCall_NSVC_LOOKUPFRAGS(void *);
/*
 * RPC handler
 */

extern NsvcLookupFragsResult *nsvc_lookupFrags(char *relname, Oid relid);
/*
 * Looks up pg_fragment tuples in local and/or nameserver catalogs.
 * First tries to find tuples with matching fraclassid, then looks
 * for matching frastoreid.
 */

extern void nsvc_freeLookupFragsResult(NsvcLookupFragsResult *result);
/* 
 * Deallocates memory.
 */

extern void nsvc_printLookupFragsResult(NsvcLookupFragsResult *result);
/* 
 * Prints it to stderr. 
 */

#endif
