/*-------------------------------------------------------------------------
 *
 * relcache.h--
 *    Relation descriptor cache definitions.
 *
 *
 * Copyright (c) 1994, Regents of the University of California
 *
 * $Id: relcache.h,v 0.4 1996/06/07 05:00:53 am Exp $
 *
 *-------------------------------------------------------------------------
 */
#ifndef	RELCACHE_H
#define RELCACHE_H

#include <sys/types.h>

#include "postgres.h"
#include "utils/rel.h"

/*
 * relation lookup routines
 */
extern Relation RelationIdCacheGetRelation(Oid relationId);
#ifndef P95
extern Relation RelationNameCacheGetRelation(Name relationName);
#else /* P95 */
extern Relation RelationNameCacheGetRelation(char *relationName);
#endif /* P95 */
extern Relation RelationIdGetRelation(Oid relationId);
#ifndef P95
extern Relation RelationNameGetRelation(Name relationName);
extern Relation getreldesc(Name relationName);
#else /* P95 */
extern Relation RelationNameGetRelation(char *relationName);
extern Relation getreldesc(char *relationName);
#endif /* P95 */

extern void RelationClose(Relation relation);
extern void RelationFlushRelation(Relation *relationPtr,
				  bool	onlyFlushReferenceCountZero);
extern void RelationIdInvalidateRelationCacheByRelationId(Oid relationId);

extern void 
RelationIdInvalidateRelationCacheByAccessMethodId(Oid accessMethodId);

extern void RelationCacheInvalidate(bool onlyFlushReferenceCountZero);

extern void RelationRegisterRelation(Relation relation);
extern void RelationPurgeLocalRelation(bool xactComitted);
extern void RelationInitialize();
extern void init_irels();
extern void write_irels();


#endif	/* RELCACHE_H */
