/*-------------------------------------------------------------------------
 *
 * pg_hostid.c--
 *    a simple program to get the internet address of a given host
 *
 * Copyright (c) 1994-5, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *    $Header: /usr/local/devel/mariposa/cvs/src/bin/pg_hostid/pg_hostid.c,v 1.1 1995/05/03 19:36:07 andrew Exp $
 *
 *-------------------------------------------------------------------------
 */
#include <stdio.h>
#include <sys/socket.h>
#include <netdb.h>

int
main(int argc, char **argv)
{
    struct hostent *hent;
    int addr;
    
    if (argc!=2) {
	fprintf(stderr, "Usage: %s hostname\n", argv[0]);
	exit(1);
    }

    if ((hent = gethostbyname(argv[1])) == NULL) {
	fprintf(stderr, "%s: Cannot get host entry for host \"%s\"\n",
		argv[0], argv[1]);
	exit(1);
    }

    bcopy(hent->h_addr, (char*)&addr, hent->h_length);
    printf("%d\n", addr);
    return 0;
}
