#!/usr/sww/bin/perl -w
# change this to your perl location

sub getHosts {
	$numhosts = 1;
	print "host #$numhosts: ";
	while (1) {
		$entry = <STDIN>;
		chop $entry;
		if ($entry eq "") {
			return;
		}
		$netaddress = &validateHost ($entry);

		if ($netaddress == -1) {
			print "Sorry, that's an invalid hostname. ";
			print "Please try again.\n";
			print "host #$numhosts: ";
			next;
		}
		$hostlist {$numhosts} = $entry;
		$hostaddrs {$numhosts} = $netaddress;
		$numhosts++;
		print "host #$numhosts: ";
	}	
}

sub printHosts {
	print "Here is the host info:\n";
	foreach $key (sort by_number keys %hostlist) {
		print "hostid: $key -> $hostlist{$key}";
		print " (address: $hostaddrs{$key})\n";
	}
}

sub validateHost {
	$address = `mp_hostaddr $_[0]`;
	if (($? >> 8) == 1) {
		return -1;
	}
	chop $address;
	return $address;
}

sub by_number {
	$a <=> $b
}

sub writeSQL {
	open (INITSQL, ">initsite.sql") || die "can't open initsite.sql";
	print INITSQL "-- initial values for the pg_host table\n";
	foreach $key (sort by_number keys %hostlist) {
		print INITSQL "-- $key $hostlist{$key}\n";
		print INITSQL "insert into pg_host ";
		print INITSQL "values ($key, $hostaddrs{$key});\n";
	}
	close (INITSQL);
}

sub writeBootstrap {
	# this is _really_ awful -- I'm going to regret this in the
	# afterlife.
	open (MPBOOTSTRAP, ">mpbootstrap.pl") || die "can't open mpbootstrap.pl";
	print MPBOOTSTRAP "\n# This scriptlet was automatically generated by siteplan.\n";
	print MPBOOTSTRAP "%reversemap = (\n";
	foreach $key (sort by_number keys %hostlist) {
		print MPBOOTSTRAP "\t$hostaddrs{$key} , $key ,\n";
	}
	print MPBOOTSTRAP "\t0 , 0 );\n";
	print MPBOOTSTRAP 'print $reversemap {$ARGV[0]};';
	print MPBOOTSTRAP "\nexit;\n";

	close (MPBOOTSTRAP);
}


print STDOUT <<WELCOME_MSG;
Welcome to the Mariposa Site Planner.
This script will help you create your
Mariposa installation.

WELCOME_MSG

print STDOUT <<FIRST;
Select the hosts on which Mariposa
will run.  We'll prompt you with the Mariposa
host identifier -- please enter a host name,
followed by _RETURN_.  When you are finished
entering names, just hit _RETURN_ at the
prompt.
FIRST

&getHosts;
print "\n\n";
&printHosts;

print "Do you wish to change any information? [n]";
$response = <STDIN>;
chop $response;
$response =~ tr/A-Z/a-z/;
if (substr ($response, 0, 1) eq 'y') {
	undef %hostlist;
	undef %hostaddrs;
	&getHosts;
}
	

print "Writing the SQL file...";
&writeSQL;
print "done.\n";

print "Writing the bootstrap program...";
&writeBootstrap;
print "done.\n";


exit (0);

