# Mariposa makefile
ifndef P95
#-------------------------------------------------------------------------
#
# postgres.lib.mk--
#    rules for building libraries. To use the rules, set the following
#    variables:
#	LIBSRCS    - source files for objects to be built in the library
#	LIB	   - name of the library (eg. LIB=pq for libpq.a)
#    postgres.mk should be included before this file.
#
# Copyright (c) 1994-5, Regents of the University of California
#
#
# IDENTIFICATION
#    $Header: /usr/local/devel/mariposa/cvs/src/mk/postgres.lib.mk,v 1.5 1996/06/07 05:03:09 am Exp $
#
#-------------------------------------------------------------------------

LIBOBJS:=	$(LIBSRCS:.c=.o)
LIBDEPENDS:=	$(addprefix $(objdir)/,$(LIBSRCS:%.c=%.d))
lib:=		lib$(LIB).a

$(lib):	$(addprefix $(objdir)/,$(LIBOBJS))
	@rm -f $(objdir)/$(lib)
ifdef MK_NO_LORDER
	cd $(objdir); $(AR) $(AROPT) $(lib) $(LIBOBJS); $(RANLIB) $(lib)
else
	cd $(objdir); $(AR) $(AROPT) $(lib) `lorder $(LIBOBJS) | tsort`; $(RANLIB) $(lib)
endif

CLEANFILES+= $(LIBOBJS) $(lib)

install::	localobj $(lib)
	$(INSTALL) $(INSTL_LIB_OPTS) $(objdir)/$(lib) $(DESTDIR)$(LIBDIR)/$(lib)
	@cd $(DESTDIR)$(LIBDIR); $(RANLIB) $(lib)

ifdef USE_DEPEND
-include $(LIBDEPENDS)
endif
# Postgres95 makefile
else # P95
#-------------------------------------------------------------------------
#
# postgres.lib.mk--
#    rules for building libraries. To use the rules, set the following
#    variables:
#	LIBSRCS    - source files for objects to be built in the library
#	LIB	   - name of the library (eg. LIB=pq for libpq.a)
#    postgres.mk should be included before this file.
#
# Copyright (c) 1994-5, Regents of the University of California
#
#
# IDENTIFICATION
#    $Header: /usr/local/devel/mariposa/cvs/src/mk/postgres.lib.mk,v 1.5 1996/06/07 05:03:09 am Exp $
#
#-------------------------------------------------------------------------

LIBOBJS:=     $(addsuffix .o, $(basename $(LIBSRCS)))
#LIBSOBJS:=    $(addsuffix .so, $(basename $(LIBSRCS)))
lib:=		lib$(LIB).a
shlib:=		lib$(LIB).so.1

ifndef LINUX_ELF
$(lib):	$(addprefix $(objdir)/,$(LIBOBJS))
else
$(lib):	$(addprefix $(objdir)/,$(LIBOBJS))
endif
	@rm -f $(objdir)/$(lib)
ifdef MK_NO_LORDER
	cd $(objdir); $(AR) $(AROPT) $(lib) $(LIBOBJS); $(RANLIB) $(lib)
else
	cd $(objdir); $(AR) $(AROPT) $(lib) `lorder $(LIBOBJS) | tsort`; $(RANLIB) $(lib)
endif

$(shlib):	$(addprefix $(objdir)/,$(LIBOBJS))
	@rm -f $(objdir)/$(shlib)
	cd $(objdir); $(CC) -shared $(LIBOBJS) -o $(shlib) 

CLEANFILES+= $(LIBOBJS) $(lib) $(shlib)

ifdef LINUX_ELF
install:: localobj $(lib) $(shlib)
	$(INSTALL) $(INSTL_LIB_OPTS) $(objdir)/$(lib) $(DESTDIR)$(LIBDIR)/$(lib)
	$(INSTALL) $(INSTL_LIB_OPTS) $(objdir)/$(shlib) $(DESTDIR)$(LIBDIR)/$(shlib)
else
install:: localobj $(lib)
	$(INSTALL) $(INSTL_LIB_OPTS) $(objdir)/$(lib) $(DESTDIR)$(LIBDIR)/$(lib)
endif
#	@cd $(DESTDIR)$(LIBDIR); $(RANLIB) $(lib)


endif # P95
