#-------------------------------------------------------------------------
#
# postgres.perl.mk--
#    rules for building perl scripts. To use the rules, set the following
#    variables:
#	SRCS    - source for the perl script
#	PERLPROG	- name of the executable
#    postgres.mk should be included before this file.
#
# Copyright (c) 1994-5, Regents of the University of California
#
#
# IDENTIFICATION
#    $Header: /usr/local/devel/mariposa/cvs/src/mk/postgres.perl.mk,v 1.1 1996/06/14 20:07:45 am Exp $
#
# NOTES
#    the perl script you write might include the following strings which
#    will be turned into the values listed below:
#
#	_fUnKy_BINDIR_sTuFf_	  -  location of installed binaries
#	_fUnKy_DATADIR_sTuFf_	  -  location of the data directory
#	_fUnKy_POSTGRESDIR_sTuFf_ -  location of the postgres "home" directory
#	_fUnKy_DASH_N_sTuFf_	  -  -n flag used in echo
#	_fUnKy_BACKSLASH_C_sTuFf_ -  continuation (echo)
#
#-------------------------------------------------------------------------

#
# And all the perl scripts here get stuffed with the default
# values for BINDIR, DATADIR, and POSTGRESDIR
#
SEDSCRIPT= -e "s^_fUnKy_BINDIR_sTuFf_^$(BINDIR)^g" \
	-e "s^_fUnKy_DATADIR_sTuFf_^$(DATADIR)^g" \
	-e "s^_fUnKy_POSTGRESDIR_sTuFf_^$(POSTGRESDIR)^g"

OBJS:= $(SRCS:%.c=%.o)

$(PERLPROG):  $(PERLPROG).*pl
	cat $< > $(objdir)/$(PERLPROG)

CLEANFILES+= $(PERLPROG)

install:	localobj $(PERLPROG)
	$(INSTALL) $(INSTL_EXE_OPTS) $(objdir)/$(PERLPROG) $(DESTDIR)$(BINDIR)/$(PERLPROG)

